#include "AccessINI.h"
#include <stdio.h>
#include <assert.h>
#include <string.h>

#define ACCINI_BUFFER_SIZE	1024*16
#if!defined(FILE_END) 
#define FILE_END 2
#endif
#if!defined(FILE_BEG)
#define FILE_BEG 0
#endif
#if!defined(FILE_CURR)
#define FILE_CURR 1
#endif

unsigned int AccINIGetPrivateProfileInt(const char* lpAppName, const char* lpKeyName,int nDefault, const char* lpFileName)
{
	if ( lpFileName == NULL || lpAppName == NULL || lpKeyName == NULL )
	{
		return nDefault;
	}

	FILE *fp = NULL;
	bool bFind = false;
	unsigned int nResult = 0;
	char *pTemp = NULL;
	
	if ( (fp = fopen(lpFileName, "rb" )) == NULL )
	{
		return nDefault;
	}

	char *pBuffer = new char[ACCINI_BUFFER_SIZE];
	char *pValidPos = NULL;//ոЧλ

	while ( true )
	{
		fgets( pBuffer, ACCINI_BUFFER_SIZE, fp );

		if ( feof(fp) )
		{
			break;
		}

		pValidPos = pBuffer;
		
		while ( *pValidPos == ' '||*pValidPos == '\t' )
		{
			pValidPos++;
		}

		pTemp = pValidPos + strlen(pValidPos) - 1;

		while ( *pTemp == ' ' || *pTemp == '\t' || *pTemp == '\n' || *pTemp == '\r' )
		{
			*pTemp -- = '\0';
		}

		if ( pValidPos[0]!='[' || pValidPos[strlen(pValidPos)-1]!=']' )
		{
			continue;
		}

		pValidPos[strlen(pValidPos)-1] = '\0';

		if ( strcmp( lpAppName, pValidPos+1 )!=0 )
		{
			continue;
		}

		while ( true )
		{
			fgets( pBuffer, ACCINI_BUFFER_SIZE, fp );
			
			pValidPos = pBuffer;
			
			while ( *pValidPos == ' '||*pValidPos == '\t' )
			{
				pValidPos++;
			}

			if ( pValidPos[0] == '[' )
			{
				break;
			}

			if ( ( pTemp = strchr(pValidPos, '=')) == NULL )
			{
				if ( feof(fp) )
				{
					break;
				}

				continue;
			}

			*pTemp = '\0';
			
			if ( strcmp(pValidPos, lpKeyName) != 0 )
			{
				if ( feof(fp) )
				{
					break;
				}
				
				continue;
			}

			sscanf( pTemp+1, "%u", &nResult );

			bFind = true;

			break;
		}

		if ( bFind )
		{
			break;
		}
	}

	delete [] pBuffer;

	assert( fp!=NULL );
	
	fclose( fp );
	
	return bFind?nResult:nDefault;
}

unsigned int AccINIGetPrivateProfileInt(CCompatibleType AppName, CCompatibleType KeyName,int nDefault, CCompatibleType FileName)
{
	return AccINIGetPrivateProfileInt( (const char*)AppName, (const char*)KeyName, nDefault, (const char*)FileName );
}

unsigned long AccINIGetPrivateProfileString(const char * lpAppName, const char * lpKeyName, const char * lpDefault, char * lpReturnedString, unsigned long nSize, const char * lpFileName)
{
	unsigned long nResult = 0;

	char *pBuffer = new char[ACCINI_BUFFER_SIZE];
	char *pValidPos = NULL;//ոЧλ

	if ( lpFileName == NULL || lpAppName == NULL || lpKeyName == NULL )
	{
		if ( lpDefault == NULL )
		{
			lpReturnedString[0] = '\0';
		}
		else
		{
			strcpy( pBuffer, lpDefault );

			if ( nSize <= (nResult = strlen(pBuffer)) )
			{
				nResult = nSize - 1;
				pBuffer[nSize-1] = '\0';
			}
			
			strcpy( lpReturnedString, pBuffer );
		}

		return nResult;
	}

	FILE *fp = NULL;
	bool bFind = false;
	char *pTemp = NULL;
	
	if ( (fp = fopen(lpFileName, "rb" )) == NULL )
	{
		return nResult;
	}

	while ( true )
	{
		fgets( pBuffer, ACCINI_BUFFER_SIZE, fp );

		if ( feof(fp) )
		{
			break;
		}

		pValidPos = pBuffer;
		
		while ( *pValidPos == ' '||*pValidPos == '\t' )
		{
			pValidPos++;
		}

		pTemp = pValidPos + strlen(pValidPos) - 1;

		while ( *pTemp == ' ' || *pTemp == '\t' || *pTemp == '\n' || *pTemp == '\r' )
		{
			*pTemp -- = '\0';
		}

		if ( pValidPos[0]!='[' || pValidPos[strlen(pValidPos)-1]!=']' )
		{
			continue;
		}

		pValidPos[strlen(pValidPos)-1] = '\0';

		if ( strcmp( lpAppName, pValidPos+1 )!=0 )
		{
			continue;
		}

		while ( true )
		{
			fgets( pBuffer, ACCINI_BUFFER_SIZE, fp );
			
			pValidPos = pBuffer;
			
			while ( *pValidPos == ' '||*pValidPos == '\t' )
			{
				pValidPos++;
			}

			if ( pValidPos[0] == '[' )//Ѿҵһڵ
			{
				break;
			}

			if ( ( pTemp = strchr(pValidPos, '=')) == NULL )
			{
				if ( feof(fp) )
				{
					break;
				}

				continue;
			}

			*pTemp = '\0';
			
			if ( strcmp(pValidPos, lpKeyName) != 0 )
			{
				if ( feof(fp) )
				{
					break;
				}
				
				continue;
			}

			sscanf( pTemp+1, "%s", pBuffer );

			bFind = true;

			break;
		}

		if ( bFind )
		{
			break;
		}
	}

	if ( bFind )
	{
		pTemp = pBuffer + strlen(pBuffer) - 1;
		
		while ( *pTemp == ' ' || *pTemp == '\t' || *pTemp == '\n' || *pTemp == '\r' )
		{
			*pTemp -- = '\0';
		}
		
		if ( nSize <= (nResult = strlen(pBuffer)) )
		{
			nResult = nSize - 1;
			pBuffer[nSize-1] = '\0';
		}

		strcpy( lpReturnedString, pBuffer );
	}
	else
	{
		if ( lpDefault == NULL )
		{
			lpReturnedString[0] = '\0';
		}
		else
		{
			strcpy( pBuffer, lpDefault );
			
			if ( nSize <= (nResult = strlen(pBuffer)) )
			{
				nResult = nSize - 1;
				pBuffer[nSize-1] = '\0';
			}
			
			strcpy( lpReturnedString, pBuffer );
		}		
	}

	delete [] pBuffer;

	assert( fp!=NULL );
	
	fclose( fp );
	
	return nResult;
}

unsigned long AccINIGetPrivateProfileString(CCompatibleType AppName,
											CCompatibleType KeyName,
											CCompatibleType Default,
											char * lpReturnedString,
											unsigned long nSize,
											CCompatibleType FileName)
{
	return AccINIGetPrivateProfileString((const char*)AppName, (const char*)KeyName, 
		(const char*)Default, lpReturnedString, nSize, (const char*)FileName );
}

bool AccINIWritePrivateProfileString(const char * lpAppName, const char * lpKeyName, const char * lpString, const char * lpFileName )
{
	if (lpAppName == NULL || lpKeyName == NULL || lpString == NULL || lpFileName == NULL )
	{
		return false;
	}

	FILE *fp = NULL;
	bool bFind = false;
	unsigned int nResult = 0;
	char *pTemp = NULL;
	
	if ( (fp = fopen(lpFileName, "rb+" )) == NULL )
	{
		return false;
	}
	
	char *pBuffer = new char[ACCINI_BUFFER_SIZE];
	char *pValidPos = NULL;//ոЧλ

	fseek( fp, 0, FILE_END );

	unsigned long nFileSize = ftell( fp );

	rewind( fp );
	
	while ( true )
	{
		fgets( pBuffer, ACCINI_BUFFER_SIZE, fp );
		
		if ( feof(fp) )
		{
			break;
		}
		
		pValidPos = pBuffer;
		
		while ( *pValidPos == ' '||*pValidPos == '\t' )
		{
			pValidPos++;
		}
		
		pTemp = pValidPos + strlen(pValidPos) - 1;
		
		while ( *pTemp == ' ' || *pTemp == '\t' || *pTemp == '\n' || *pTemp == '\r' )
		{
			*pTemp -- = '\0';
		}
		
		if ( pValidPos[0]!='[' || pValidPos[strlen(pValidPos)-1]!=']' )
		{
			continue;
		}
		
		pValidPos[strlen(pValidPos)-1] = '\0';
		
		if ( strcmp( lpAppName, pValidPos+1 )!=0 )
		{
			continue;
		}
		else
		{
			bFind = true;
			break;
		}
	}

	if ( bFind )
	{
		sprintf( pBuffer, "%s%c%s%c%c", lpKeyName, '=',lpString , 0x0d, 0x0a);		
		long nBlockSize = strlen(pBuffer);
		char *pTempBuffer = new char[nBlockSize];
		char *pTemp, *pInput = pTempBuffer, *pOutput = pBuffer;
		long nCharstoMove = nFileSize - ftell( fp );

		for(long nCount=nCharstoMove/nBlockSize; nCount>0; nCount-- )
		{
			fread( pInput, nBlockSize, 1, fp );
			fseek( fp, -nBlockSize, FILE_CURR );
			size_t m=fwrite( pOutput, nBlockSize, 1, fp );
			fflush( fp );//ûнfseek
			pTemp = pInput; pInput = pOutput; pOutput = pTemp;
		}

		if ( nCharstoMove % nBlockSize != 0 )
		{
			fread( pInput, nCharstoMove%nBlockSize, 1, fp );
			fseek( fp, -nCharstoMove%nBlockSize, feof(fp)?FILE_END:FILE_CURR );
			fwrite( pOutput, nBlockSize, 1, fp );
			fwrite( pInput, nCharstoMove%nBlockSize, 1, fp );
			fflush( fp );
		}
		else
		{
			fwrite( pOutput, nBlockSize, 1, fp );
			fflush( fp );
		}

		delete [] pTempBuffer;
	}
	else
	{
		fseek( fp, 0, FILE_END );
		fprintf( fp, "%c%c%s%s%s%c%c%s%c%s",0x0d, 0x0a, "[", lpAppName, "]",0x0d, 0x0a, lpKeyName, '=',lpString );
	}

	delete [] pBuffer;
	fclose( fp );

	return true;
}

bool AccINIWritePrivateProfileString( CCompatibleType AppName, CCompatibleType KeyName, CCompatibleType String, CCompatibleType FileName )
{
	return AccINIWritePrivateProfileString( (const char *) AppName, (const char *) KeyName, (const char *) String, (const char *) FileName );
}

bool AccINIWritePrivateProfileInt(const char * lpAppName, const char * lpKeyName, unsigned long nValue, const char * lpFileName )
{
	char *lpBuffer = new char[ACCINI_BUFFER_SIZE];
	sprintf( lpBuffer, "%d", nValue );
	bool bResult = AccINIWritePrivateProfileString( lpAppName, lpKeyName, lpBuffer, lpFileName );
	delete [] lpBuffer;
	return bResult;
}


bool AccINIWritePrivateProfileInt( CCompatibleType AppName, 
								  CCompatibleType KeyName,
								  unsigned long nValue, 
								  CCompatibleType FileName )
{
	return AccINIWritePrivateProfileInt( (const char *)AppName, (const char*)KeyName, nValue, (const char*)FileName );
}
