//#define __EXP_USED_BY_COMPILER//ڹнк궨壬ʹ˴벻޸ļֲʹ
#if!defined(WIN32)
//#define __EXP_USED_BY_COMPILER
#endif

#pragma once

#ifndef NULL
#ifdef __cplusplus
#define NULL    0
#else
#define NULL    ((void *)0)
#endif
#endif

#ifndef TRUE
#define TRUE 1
#endif

#ifndef FALSE
#define FALSE 0
#endif

#ifndef ASSERT
#include <assert.h>
#ifdef _DEBUG
#define ASSERT(x)	assert(x)
#else
#define ASSERT(x)	((void)NULL)
#endif
#endif

#ifndef VERIFY
#ifdef _DEBUG
#define VERIFY(x)	assert(x)
#else
#define VERIFY(x)	(void(x))
#endif
#endif

#ifndef _BYTE_DEFINED
#define _BYTE_DEFINED
typedef unsigned char BYTE;
#endif // !_BYTE_DEFINED

#define INVALIDOP	'\n'

#include <cstdio>

#ifdef __cplusplus
#include <vector>
#define ctaState DsState
class DsState;
#endif

#ifdef __cplusplus
extern "C"{
#endif
	
	//zhangwl
	typedef enum{opADD='+',opSUB='-',opMUL='*',opDIV='/',opMOD='%',opAND='&',opOR='|',
		opNOT='!',opUNIMUS='-',opGT=4,opGE=5,opLT=2,opLE=3, opEQ=1, opNotEQ = 6,
		opCOND=7, opCOND1='?', opCOND2=':', opINVALIDOP=INVALIDOP} OPTYPE;
	long i2xComputeExp(const long nVal1, const long nVal2, OPTYPE chOpType);
	OPTYPE translateCmpOp(const char *strOp );
	void dealWithConst(void *pYYSTYPE_Exp);
	void *MakeExpNode(OPTYPE opType, void *pLeftOp, void *pRightOp, void *pParent );
	void OutputAndClear1ExpTree(void *pRoot);
	void output2xml( void * );
	void CheckCmpExp( void *pRoot );
#ifdef __cplusplus
}
#endif

#ifdef __cplusplus
class CExp
{
	class CNode;
public:
#if!defined( __EXP_USED_BY_COMPILER )//ڱʹ
	enum { ConstExp, OneVarExp, OneOpExp, TwoOpExp, OverTowOpExp } m_ExpOpNumType;
	bool readINI(const char *FileName, const char *Section, const char *Item );	
	bool readINI(const char *FileName, const long nExpId );
	CExp(): m_pBinaryTree(NULL), m_pszVar(NULL)/*, m_spfunctionGetValByID( NULL )*/,
	m_nCurrTreeSize(0), m_nCurrVarNum(0)/*, m_pCurrState(NULL)*/ {
	}
	static void SetFuncGetValById(long (*GetValById)(const ctaState *pState, int nValId));
	static void SetCurrentState( const ctaState *pState );
	void SetVarId2BinaryTree();
	void UpdateVal( );
	long GetLeftVarId();
	OPTYPE GetRootOpType();
	CExp GetRightSubExp();
	virtual long UpdateAndCmptRightVal();
	CExp(const CExp &Other);
	CExp &operator = (const CExp &Other);
#else//ڱʹ
	void writeINI(FILE *fp, const long nExpId );
	CExp():m_nDefaultSize( 1024 ),m_nStackTop( 0 ),
		m_nDefaultVarSize( 256 ), m_nVarStackTop( 0 )
	{
		m_pBinaryTree = new CNode[m_nDefaultSize];
		m_pszVar = new VAR [m_nDefaultVarSize];
	}
	CExp(const CExp &Other);
	CExp &operator = (const CExp &Other);
	long AddLeftChild(long nRoot, long nVal);
	long AddRightChild(long nRoot, long nVal);
	void SetLeftChild(long nRoot, long nLeftChild );
	void SetRightChild(long nRoot, long nRightChild );
	long AddNode(long nVal,OPTYPE OpType = opINVALIDOP);
	void AddVar2Set(long nVarPos,long nVarId);
	void Clear();
	long m_nStackTop;
private:
	const long m_nDefaultSize;
	const long m_nDefaultVarSize;
	long m_nVarStackTop;
	void OrientationWritePos(FILE *&fp);
public:
	void AppointRoot(long nRoot); 
#endif
	~CExp()
	{
		if ( NULL != m_pBinaryTree )
		{
			delete [] m_pBinaryTree;
		}

		if ( NULL != m_pszVar )
		{
			delete [] m_pszVar;
		}
	}
public:
	CNode	*m_pBinaryTree;
	typedef struct _tagVAR {
		long m_nPos2Set;
		long m_nVarId;
	} VAR;
	VAR *m_pszVar;
	long	m_nRoot;
private:
	class CNode//ûָԱǳ
	{
	public:
		long m_nVal;
		long m_nId;
		OPTYPE m_OpType;
		long m_nLeft;
		long m_nRight;
		CNode()
		{
			Clear();
		}
		void Clear();
	protected:
	private:
	};

#if!defined( __EXP_USED_BY_COMPILER )//ڱʹ
public:
	virtual long Compute();
	long UpdateValAndCompute();
	//long (*Compute)();
	static long (*m_spfunctionGetValByID)( const ctaState *pState , int nValId);
	static ctaState *m_spCurrState;
protected:
public:
	long m_nVarNum;
protected:
	long m_nTreeSize;
	long m_nCurrVarNum;
	long m_nCurrTreeSize;
	
	bool CExp::OrientationReadPos(FILE *&fp, const char *lpAppName, const char *lpKeyName);
	void JudgeExpType();
#endif
#ifdef _DEBUG
public:
	void dbgOutput();
	void dbgOutput( CNode &Node );
#endif
};
#endif

#if defined(__EXP_USED_BY_COMPILER)//ҪṩCӿ
#ifdef __cplusplus
extern "C"{
#endif
	long AddLeftChild(long nRoot, long nVal);
	long AddRightChild(long nRoot, long nVal);
	long AddNode(long nVal,OPTYPE chOp);
	void AddVar2Set(long nVarPos,long nVarId);
	void expClear();
	void SetLeftChild(long nRoot, long nLeftChild );
	void SetRightChild(long nRoot, long nRightChild );
	extern long g_nCurrRoot;
	void expWriteINI(long nExpId);
	void expSetExpNum(long nExpNum);
	long expGetExpNum();
	void AppointRoot(long nRoot); 
	extern FILE *g_fpOutputObj;
#ifdef __cplusplus
}
#endif
#else
#ifndef WIN32
char *ltoa(long, char *, int);
#endif
#endif

#ifndef MAX_NUM_LEN
#define MAX_NUM_LEN	50
#endif
