#include "atomProperty.h"
#include <assert.h>

bool AtomProperty::isSatisfy(const DsState &sta) const
{
  bool result;
  int tmp, i;
  
  if(m_type == 1)
  {
    //k > 3
    tmp = sta.sharedVarVal[m_var_id-1];
    result = Compare(tmp, m_relation, m_boundary);
    if(m_is_not == 1)
      result = !result;

    return result;
  }
  else if(m_type == 2)
  {
    //P1.x > 3
    for(i = 0; i < sta.clockId.size(); i++)
    {
      if(sta.clockId[i] == m_var_id)
        break;
    }
    if(i == sta.clockId.size()) //not find, this clock isn't active
    {
      if(m_is_not == 1)
        return false;

      return true;
    }
    assert( i < sta.clockId.size());
    result = Compare(sta.clockVarVal[i], m_relation, m_boundary);

    if(m_is_not == 1)
      result = !result;

    return result;
  }
  else
  {
    //p1.3
    assert(m_type == 3);
	assert(m_process >= 1);
    tmp = sta.pLoc[m_process-1];
    if(m_loc_id == tmp)
      result = true;
    else
      result = false;

    if(m_is_not == 1)
      result = !result;

    return result;
  }

  assert(false);
}
//жleft RELATION right Ƿ
bool AtomProperty::Compare(int left,RELATION rel,int right) const
{
	switch(rel) 
	{
	case G:
		if(left > right)
			return true;
		break;
	case GE:
		if(left >= right)
			return true;
		break;
	case L:
		if(left < right)
			return true;
		break;
	case LE:
		if(left <= right)
			return true;
		break;
	case EQ:
		if(left == right)
			return true;
		break;
	case NE:
		if(left != right)
			return true;
		break;
	default:
		std::cout << "ERROR! In CAtomProperty::Compare()\n";
	}
	
	return	false;
}

void AtomProperty::Output(std::ostream &os, int idx)
{
	os << "atom" << idx << std::endl;

	os << "isNot:" << m_is_not;
	if(m_type == 1 || m_type == 2)
	{
		// K > 3
		os << "\tvarId:" << m_var_id << "\tRelation:" << m_relation << "\tBound:" << m_boundary << std::endl;
	}
	else
	{
		assert(m_type == 3);
		os << "\tprocId:" << m_process << "\tlocId:" << m_loc_id << std::endl;
	}
}
