#include "composition.h"

Composition::Composition(System *sys, int allPermNum, int ctaNum)
  :pSystem(sys), permNum(allPermNum), transRuleSize(0)
{
//  std::cout << "Composition constructor" << std::endl;
//  std::cout << "sizeof(transrules):" << sizeof(transRules) << std::endl;
	pLocPermArr = new int*[permNum];
	for(int i = 0; i < permNum; i++)
		pLocPermArr[i] = new int[ctaNum];
	
	past = new int[permNum];
	
	for(int j = 0; j < permNum; j++)
		past[j] = 0;
	
	transRules.clear();
	transRules.resize(permNum);
	

  std::vector<int> initLoc;
  GetInitLocPerm(initLoc);
  GetCoef();
  initLocPermNum = VecToInt(initLoc);
  
  for(int k = 0; k < initLoc.size(); k++)
	  pLocPermArr[initLocPermNum][k] = initLoc[k];
//  std::cout << "construct done" << std::endl;
}

Composition::~Composition()
{
  int i;
 // std::cout << "compostion destruct begin" << std::endl;
  std::list<CompTransition*>::iterator ite;
  
  for(i = 0; i < transRules.size(); i++)
  {
    for(ite = transRules[i].begin(); ite != transRules[i].end(); ite++)
      delete *ite;
  }

  for(i = 0; i < permNum; i++)
    delete []pLocPermArr[i];
  delete []pLocPermArr;
  delete []past;
  std::cout << "composition destruct end" << std::endl;
}

void Composition::GetCoef()
{
  int i;
  
  for(i = 0; i < pSystem->m_cta.size(); i++)
    coef.push_back(1);

  for(i = pSystem->m_cta.size() - 2; i >= 0; i--)
    coef[i] = coef[i+1] * pSystem->m_cta[i+1].locNum;
  
}

void Composition::GetInitLocPerm(std::vector<int> &init)
{
  init.clear();

  for(int i = 0; i < pSystem->m_cta.size(); i++)
    init.push_back(pSystem->m_cta[i].initLocId);
}

//vecдŵlocationIdתΪһ
int Composition::VecToInt(std::vector<int> &vec)
{
  int rlt = 0;

  assert(vec.size() == pSystem->m_cta.size());

  for(int i = 0; i < pSystem->m_cta.size(); i++)
    rlt += (vec[i] - 1) * coef[i];

  if(rlt < 0)
  {
    std::cout << "ERROR! Overflow in VecToInt()!" << std::endl;
    return -1;
  }

  return rlt;
}

int Composition::GetTransRules()
{
  std::vector<int> initLoc;

  std::cout << "GetTransRules" << std::endl;
  GetInitLocPerm(initLoc);
  GetCoef();
  initLocPermNum = VecToInt(initLoc);


  todo.push(initLoc);
  
  std::cout << "possible locNum after composition:\t" << permNum << std::endl;
  past[initLocPermNum] = 1;

  for(int k = 0; k < initLoc.size(); k++)
    pLocPermArr[initLocPermNum][k] = initLoc[k];

  while(!todo.empty())
  {
	std::vector<int> &tmp = todo.front();
    
	GetAllTrans(tmp);
	todo.pop();
  }

  std::cout << "Get transrules done, transtrule size:\t" << transRuleSize << std::endl;

  return 1;
}

//Get all the transitions from the location
//õlocPermlocationϳеǨƹ
void Composition::GetAllTrans(std::vector<int> &locPerm)
{
  int locPermNum = VecToInt(locPerm);
 // assert(past[locPermNum] == 1);

  int i, j, k;
  Transition *pTrans, *tmpPTrans;

  for(i = 0; i < locPerm.size(); i++)
  {
    int locId = locPerm[i];
    for(j = 0; j < pSystem->m_cta[i].m_loc[locId-1].jumpOut.size(); j++)
    {
      std::vector<int> newLocPerm(locPerm);
      pTrans = &(pSystem->m_cta[i].m_loc[locId-1].jumpOut[j]);
      if(pTrans->syn <= 0)
      {
        // no syn
        newLocPerm[i] = pTrans->post;
        int newLocPermNum = VecToInt(newLocPerm);
       
        if(past[newLocPermNum] == 0)
               {
                 for(int m = 0; m < newLocPerm.size(); m++)
                   pLocPermArr[newLocPermNum][m] = newLocPerm[m];
               }
       
		CompTransition* compTrans = new CompTransition;
        compTrans->noGuard = pTrans->noGuard;
        compTrans->pre = locPermNum;
        compTrans->post = newLocPermNum;
        compTrans->updateList = pTrans->updateList;
        compTrans->isUrgent = pTrans->isUrgent;
        compTrans->guard = pTrans->guard;
        compTrans->procId.push_back(i);
        //2007.1.20
        compTrans->resetClockId = pTrans->resetClockId;
		//֤resetIdеid
		std::sort(compTrans->resetClockId.begin(), compTrans->resetClockId.end());
        //insert the transrules
        if(compTrans->isUrgent)
        {
          //put urgent transition rules at the begin
          transRules[locPermNum].push_front(compTrans);
        }
        else
        {
          //put un-urgent transition rules at the end
          transRules[locPermNum].push_back(compTrans);
        }
        transRuleSize++;
      }//if no syn
      else if(pTrans->isBroadcast)
      {
        //broadcast
        if(pTrans->synType == 0)
          continue;

        std::vector<int> tmpProcId;
        std::vector<Transition*> tmpTransitionPointer;
        int unSuccess = 0;
        for(k = 0; k < locPerm.size(); k++)
        {
          if(k == i)
            continue;
		  //鿴ǰй㲥idǷеǰ㲥
          if(pSystem->m_cta[k].broadcastId.size() > 0)
          {
            int tmp_i, flag = 0;
            for(tmp_i = 0; tmp_i < pSystem->m_cta[k].broadcastId.size(); tmp_i++)
            {
              if(pSystem->m_cta[k].broadcastId[tmp_i] == pTrans->syn)
              {
                flag = 1;
                break;
              }
            }
            if(flag == 1)
            {
              //m_cta[k] has the same broadcast id with m_cta[i]
              //check whether there is a jump in locPerm[k] that has the broadcast id
              int tmpLocId = locPerm[k];
              int FindSynInLoc = 0;
              for(int tmp_j = 0; tmp_j < pSystem->m_cta[k].m_loc[tmpLocId-1].jumpOut.size(); tmp_j++)
              {
                tmpPTrans = &(pSystem->m_cta[k].m_loc[tmpLocId-1].jumpOut[tmp_j]);
                if(tmpPTrans->syn == pTrans->syn)
                {
					assert(tmpPTrans->synType == 0);
					tmpProcId.push_back(k);
					tmpTransitionPointer.push_back(tmpPTrans);
					FindSynInLoc = 1;
					break;
                }
              }
              if(FindSynInLoc == 0)
              {
                unSuccess = 1;
                break; // break out of for(k = 0
              }
            }//if(flag == 1)
          }//if m_cta[k; has broadcastId
        }//for(k=0

        if(unSuccess == 1) // can not broadcast in this locperm
          continue;
        if(tmpProcId.size() == 0)
        {
          std::cout << "Error: there must be at least a jump syn with a broadcast edge" << std::endl;
          return;
        }

        //at least one jump syn with this edge
        assert(tmpProcId.size() > 0);
        assert(tmpProcId.size() == tmpTransitionPointer.size());
        newLocPerm[i] = pTrans->post;
        for(k = 0; k < tmpProcId.size(); k++)
          newLocPerm[tmpProcId[k]] = tmpTransitionPointer[k]->post;

        int newLocPermNum = VecToInt(newLocPerm);

        if(past[newLocPermNum] == 0)
        {
          for(int m = 0; m < newLocPerm.size(); m++)
            pLocPermArr[newLocPermNum][m] = newLocPerm[m];
        }


        //get new compTransition
        CompTransition* compTrans = new CompTransition;
        compTrans->noGuard = pTrans->noGuard;
        k = 0;
        while(compTrans->noGuard && k < tmpTransitionPointer.size())
          compTrans->noGuard = compTrans->noGuard && tmpTransitionPointer[k++]->noGuard;

        compTrans->pre = locPermNum;
        compTrans->post = newLocPermNum;
        compTrans->guard = pTrans->guard;
        compTrans->updateList = pTrans->updateList;
        compTrans->procId.push_back(i);
        //added 2007.1.20
        compTrans->resetClockId = pTrans->resetClockId;
        
        k = 0;
        while(k < tmpTransitionPointer.size())
        {
          compTrans->updateList.insert(compTrans->updateList.end(), tmpTransitionPointer[k]->updateList.begin(), tmpTransitionPointer[k]->updateList.end());
          compTrans->guard.insert(compTrans->guard.end(), tmpTransitionPointer[k]->guard.begin(), tmpTransitionPointer[k]->guard.end());
          compTrans->procId.push_back(tmpProcId[k]);
          //added 2007.1.20
          compTrans->resetClockId.insert(compTrans->resetClockId.end(), tmpTransitionPointer[k]->resetClockId.begin(), tmpTransitionPointer[k]->resetClockId.end());
          
          k++;
        }
		//֤resetIdеid2007.2.8
		std::sort(compTrans->resetClockId.begin(), compTrans->resetClockId.end());
        //add compTrans to transRules
        //if isBroadcast, the transition must be un-urgent
        transRules[locPermNum].push_back(compTrans);
        transRuleSize++;
      }
      else
      {
        //synch not broadcast
        assert(!pTrans->isBroadcast);
        if(pTrans->synType == 0)
          continue;

        for(k = 0; k < locPerm.size(); k++)
        {
          if(k == i)
            continue;

          int tmpLocId = locPerm[k];
          for(int tmp_j = 0; tmp_j < pSystem->m_cta[k].m_loc[tmpLocId-1].jumpOut.size(); tmp_j++)
          {
            tmpPTrans = &(pSystem->m_cta[k].m_loc[tmpLocId-1].jumpOut[tmp_j]);

            if(tmpPTrans->syn == pTrans->syn)
            {
			  //?
              if(tmpPTrans->synType == 1)
                continue;

              newLocPerm[i] = pTrans->post;
              newLocPerm[k] = tmpPTrans->post;

              int newLocPermNum = VecToInt(newLocPerm);
			  if(past[newLocPermNum] == 0)
			  {
				  for(int m = 0; m < newLocPerm.size(); m++)
					  pLocPermArr[newLocPermNum][m] = newLocPerm[m];
			  }
              CompTransition* compTrans = new CompTransition;
              compTrans->noGuard = pTrans->noGuard && tmpPTrans->noGuard;
              compTrans->pre = locPermNum;
              compTrans->post = newLocPermNum;
              compTrans->guard = pTrans->guard;
              compTrans->guard.insert(compTrans->guard.end(), tmpPTrans->guard.begin(), tmpPTrans->guard.end());
              compTrans->updateList = pTrans->updateList;
              compTrans->updateList.insert(compTrans->updateList.end(), tmpPTrans->updateList.begin(), tmpPTrans->updateList.end());
			  compTrans->resetClockId = pTrans->resetClockId;
			  compTrans->resetClockId.insert(compTrans->resetClockId.end(), tmpPTrans->resetClockId.begin(), tmpPTrans->resetClockId.end());
			  compTrans->procId.push_back(i);
              compTrans->procId.push_back(k);

			  //֤resetIdеid2007.2.8
			  std::sort(compTrans->resetClockId.begin(), compTrans->resetClockId.end());
              //add to transRules
              transRules[locPermNum].push_back(compTrans);
              transRuleSize++;
            }
          }
        }//for(k=0
      }//else syn not broadcast
    }//for(j
  }//for(i
}//GetAllTrans


  
void Composition::OutputTrans(std::ostream& os)
{
  os << "--------------------------Composed Transitions---------" << std::endl;
  int size = 0;
  for(int i = 0; i < permNum; i++)
  {
    std::list<CompTransition*>::iterator ite;
    for(ite = transRules[i].begin(); ite != transRules[i].end(); ite++)
    {
      (*ite)->Output(os, ++size);
    }
  }
}
