#include <iostream>
#include <fstream>
#include <assert.h>
#include "system.h"
#include "composition.h"
#include "stateSpace.h"
//#include "time.h"
#if defined(WIN32)
#include "windows.h"
#else
#include "MyWin.h"
#endif
long getVarVal(const DsState *sta, int varId);

//Cudd Manager;
System *pSystem = NULL;
int main(int argc, char *argv[])
{
	DWORD start, end;		//ͳִʱ
	FILE *pinfo;
	bool notUnviseSta = false;
	bool unfoldDS = false;

#if defined(WIN32)
	start	=	GetTickCount();
#else
	timecompute::SetTime();
#endif

	if(argc == 1)
	{
		std::cout << "Error! There must be a obj file path" << std::endl;
		return 1;
	}

	//ֻһΪ˳֣һΪobjļ·
	assert(argc >= 2);
	//ļ·
	std::string FileName = argv[1];
	std::cout << "obj file name:" << FileName << std::endl;
	std::string OutputFileName = FileName + "------modelInfo.txt";
	std::string rltFileName = FileName + "-----cuddManagerInfo.txt";
	pinfo = fopen(rltFileName.c_str(), "w");
	if(pinfo == NULL)
	{
		std::cout << "ERROR! Can't open file!" << std::endl;
		return 1;
	}

	std::ofstream outFile(OutputFileName.c_str());
	if(!outFile)
	{
		std::cout << "Error!Can not open file " << OutputFileName << std::endl;
		return 1;
	}
	std::cout << "sizeof(composition):" << sizeof(Composition) << std::endl;
	
	System sys;
	sys.ImportSystem(FileName);
	sys.LoadProperty(FileName);
	sys.GetLocPermNum();
//	sys.Output(std::cout);
//	sys.Output(outFile);
	
	pSystem = &sys;
	Composition comp(&sys, sys.locPermNum, sys.m_cta.size());
//	comp.GetTransRules();
	

/*
	end = GetTickCount() - start;
	outFile.close();
	fclose(pinfo);
	std::cout << "execute time:" << end << std::endl;
	return 0;*/


//	comp.OutputTrans(std::cout);
	comp.OutputTrans(outFile);
	std::string tmpStr;
	for(int k = 2; k < argc; k++)
	{
		tmpStr = argv[k];
		if(tmpStr == "-n")
			notUnviseSta = true;
		if(tmpStr == "-t")//Ҫʱ
			unfoldDS = true;
	}


	CExp::SetFuncGetValById(getVarVal);
	
	StateSpace staSpace(&sys, &comp);
	staSpace.GenAndCheck(pinfo, notUnviseSta,unfoldDS);
	staSpace.Output(outFile);
#if defined(WIN32)
	end = GetTickCount() - start;
#endif
	for(int i = 0; i < pSystem->m_property.size(); i++)
		std::cout << "property" << i+1 << " : " << staSpace.m_result[i] << std::endl;
	
	staSpace.m_pCudd->DebugCheck();
	outFile.close();
	fclose(pinfo);
	std::cout << "execute time:" 
#if defined(WIN32)
	<< end << std::endl;
#else
	;
	timecompute::PrintTime();
#endif
	std::cout << "transrule size:" << comp.transRuleSize << std::endl;
	return 0;
}

long getVarVal(const DsState *sta, int varId)
{
  int i;

  if(pSystem->m_var[varId-1].m_Type == 0)
  {
    //shared var
    return sta->sharedVarVal[varId-1];
  }
  else
  {
    assert(pSystem->m_var[varId-1].m_Type == 1);
    for(i = 0; i < sta->clockId.size(); i++)
    {
      if(sta->clockId[i] == varId)
        return sta->clockVarVal[i];
    }
  }

  return -1;
}





















