#include "stateSpace.h"

#define CLOCKMAXNUM 20
int dsNumInPastList = 0;
//defined in modelcheck.cpp
extern long getVarVal(const DsState *sta, int varId);

StateSpace::StateSpace(System *pModel, Composition *pComp)
  :m_pModel(pModel), m_pComp(pComp), totalBit(0), locBit(0),
   m_WaitList(pComp->permNum)
{
	DsState::procNum = m_pModel->procNum;
  index = -1;
  nonClkVarBitNum = 0;
  clkVarBitNum = 0;
  isUnvise = true;
  unfoldDS = false;
}

StateSpace::~StateSpace()
{
  //release the resources we newed
  if(m_pModel->shareVarNum != 0)
    delete []nonClkVarBitBeginIndex;

  delete []locBitNum;

  for(int i = 0; i < m_pModel->procNum; i++)
    delete []clkVarBeginIndex[i];

  delete []clkVarBeginIndex;
  delete []procBitBeginIndex;    
}

int StateSpace::InitStateSpace()
{
	std::cout << "InitStateSpace" << std::endl;
	int i;
	int propNum, varNum, procNum;
	int locNum;
	int varBit		=	0;
	int clkNum		=	0;
	int nonClkNum	=	0;

	propNum		=	m_pModel->propertyNum;
	varNum		=	m_pModel->m_var.size();
	procNum		=	m_pModel->procNum;
	
	//existʿʼΪfalsealwaysʣʼΪtrueдcheckpropertyʱҪע
	//existΪtrueͲcheckalwaysΪfalseͲcheck
	for(i = 0; i < propNum; i++)
	{
		if(m_pModel->m_property[i].type == 0)
		{
			m_result.push_back(FALSE);
		}
		else
		{
			assert(m_pModel->m_property[i].type == 1);
			m_result.push_back(TRUE);
		}
	}

	if(m_pModel->shareVarNum > 0)
	{
		nonClkVarBitBeginIndex	=	new int [m_pModel->shareVarNum + 1];
	}

	//ñзʱӱҪλ
	for(i = 0; i < varNum; i++)
	{
		if(m_pModel->m_var[i].m_Type == 1)
		{
			clkNum++;
			clkVarBitNum += m_pModel->m_var[i].m_Bit;
		}
		else
		{
			assert(m_pModel->m_var[i].m_Type == 0);
			
			nonClkVarBitBeginIndex[nonClkNum++]	=	nonClkVarBitNum;
			m_pModel->m_var[i].m_CodeBeginIndex	=	nonClkVarBitNum;
			nonClkVarBitNum	+=	m_pModel->m_var[i].m_Bit;
		}
	}
	if(nonClkNum > 0)
	{
		//һĿʼλ
		//һЩ߽ϵжϣȽϷ
		nonClkVarBitBeginIndex[nonClkNum]	=	nonClkVarBitNum;
	}

	locBitNum	=	new int [procNum];
	//clkVarBeginIndex[i][j]Ϊi̵ĵjıģͱеĿʼindexjΪ0ʱʾǰ
	//ʱӱĸ
	clkVarBeginIndex	=	new int* [procNum];
	for(i = 0; i < procNum; i++)
		clkVarBeginIndex[i]	=	new int[CLOCKMAXNUM];

	procBitBeginIndex	=	new int[procNum+1];
	//ñÿlocationҪλ
	for(i = 0; i < procNum; i++)
	{
		locNum		=	m_pModel->m_cta[i].m_loc.size();
		locBitNum[i]=	GetBitNum(locNum);
		locBit		+=	locBitNum[i];	
	}
	
	//Ҫλ  빲λ + ʱӱλ + locationҪλ
	totalBit	=	nonClkVarBitNum + clkVarBitNum + locBit;
	
	std::cout << "locBit: " << locBit << "\tclkVarBitNum: " << clkVarBitNum 
		<< "\tnonClkVarBitNum: " << nonClkVarBitNum << std::endl;
	std::cout << "totalBit: " << totalBit << std::endl;
	
	//ʼcuddṹ״̬ռ
	Cudd mgr(totalBit, 0);
	manager		=	mgr;
	m_pCudd		=	&manager;
	std::cout << "initStatespace done" << std::endl;
	return 0;
}

//رnumҪĶλ
int StateSpace::GetBitNum(int num)
{
	int i	=	0;
	
	//0num1num
	num	-=	1;
	while ( num != 0 )
	{
		num	=	num >> 1;
		i++;
	}
	
	return i;
}

//õʼsdsStateõϢ
//ÿʱӱһbddıʾռλϢ
int StateSpace::GetInitState(SdsState &initSdsState)
{
	assert(m_pModel != NULL);
	assert(m_pComp != NULL);

	int i, j, k, m;
	int locId, clkId;
	int tmpIdx, tmpNum, nonClkVarNum;
	std::vector<int> tmpClkId;

	DsState &sta = initSdsState.sdsHead;
	
	sta.locPermNum = m_pComp->initLocPermNum;
	sta.pLoc = m_pComp->pLocPermArr[sta.locPermNum];

	tmpNum = nonClkVarNum = 0;
	for(i = 0; i < m_pModel->m_var.size(); i++)
	{
		if(m_pModel->m_var[i].m_Type == 0)
          
		{
			sta.sharedVarVal.push_back(m_pModel->m_var[i].m_InitVal);
			nonClkVarNum++;
		}
	}

	tmpNum = nonClkVarBitNum;
	for(i = 0, tmpIdx = 0; i < m_pModel->m_cta.size(); i++)
	{
		procBitBeginIndex[i] = tmpNum;

		locId = m_pModel->m_cta[i].initLocId;
		tmpNum += locBitNum[i];

		//insert clocks
		int actClkSize = m_pModel->m_cta[i].m_loc[locId-1].actClkId.size();
		
		//ָǰprocessлʱӵĸclkVarBeginIndex[i][1...activeClkSize]洢activeClkSizeʱģͱеλ
		clkVarBeginIndex[i][0] = actClkSize;
		for(j = 0; j < actClkSize; j++)
		{
			clkId = m_pModel->m_cta[i].m_loc[locId-1].actClkId[j];
			sta.clockVarVal.push_back(m_pModel->m_var[clkId-1].m_InitVal);
            sta.clockId.push_back(clkId);
			tmpClkId.push_back(clkId);

            //jʱģͱеĿʼλ
            clkVarBeginIndex[i][j+1] = tmpNum;
            m_pModel->m_var[clkId-1].m_CodeBeginIndex = tmpNum;

            tmpNum += m_pModel->m_var[clkId-1].m_Bit;
		}

        //ԵǰеlocationϵĻʱӽм飬Ƿڳʼlocation
        //ʱбУڣøʱӵıϢ
        for(k = 0; k < m_pModel->m_cta[i].m_loc.size(); k++)
        {
          if((k+1) == locId)
            continue;

          actClkSize = m_pModel->m_cta[i].m_loc[k].actClkId.size();
          for(m = 0; m < actClkSize; m++)
          {
            clkId = m_pModel->m_cta[i].m_loc[k].actClkId[m];
            //find if clkId is in initLoc's actClkId
            if(find(tmpClkId.begin(), tmpClkId.end(),
                    clkId) == tmpClkId.end())
            {
              //clkId is not active in the init Location, so we should get the code information
              clkVarBeginIndex[i][j+1] = tmpNum;
              m_pModel->m_var[clkId-1].m_CodeBeginIndex = tmpNum;
              tmpNum += m_pModel->m_var[clkId-1].m_Bit;
			  tmpClkId.push_back(clkId);
              j++;
              clkVarBeginIndex[i][0]++; //iлʱӵĸ
            }
          }//for(m
        }//for(k=0
	}

    procBitBeginIndex[i] = totalBit;
    //assert(clkVarNum = tmpIdx);
//    initSdsState.Output(std::cout);
	//õÿʱӱÿlocationеĲԼеֵСֵ
 //   m_pModel->pExp[0].SetCurrentState(&initSdsState.sdsHead);
	setVariableRangeInLoc();
	return 1;
}
//generate the statespace and check the property
int StateSpace::GenAndCheck(FILE *pinfo, bool notUnviseSta, bool unfold_DS)
{
  SdsState initSds;
  BDD DsBddSet, zero;
  int maxSdsNumInWaitingList = 1;

  if(notUnviseSta)
	  isUnvise = false;
  unfoldDS = unfold_DS;

  InitStateSpace();
  GetInitState(initSds);
  zero = manager.bddZero();
  m_WaitList[initSds.sdsHead.locPermNum].push_back(initSds);
  m_pastList = zero;
  index = initSds.sdsHead.locPermNum;
  std::cout << "begin checking" << std::endl;
  while(1)
  {
    DsBddSet = zero;

    std::list<SdsState> sdsVec;
    std::list<SdsState>::iterator ite;
#ifdef _DEBUG
//	std::cout << "m_past:";
//	m_pastList.PrintMinterm();
#endif

    index = GetSdsIndexFromWaitingList();
    
    if(index == -1)
      //waiting is empty
      break;

    ite = m_WaitList[index].begin();

    while(ite != m_WaitList[index].end())
    {
      SdsState &tmpSds = *ite;
#ifdef _DEBUG
	  std::cout << "Get sds from waitlist:" << std::endl;
	  tmpSds.Output(std::cout);
#endif
	  
      //tmpSds is the sdsState we get from waitinglist
      //and we should get the ds state, and insert the DsStates
      //into pastList and unvise them if necessary(only insert
      //and unwise the states that were not generated before
      std::vector<DsState> dsVec, staInserted;
      std::vector<int> offset;
      //get the dsState in the tmpSds
      GetDsStateInSDS(tmpSds, dsVec);
#ifdef _DEBUG
	  std::cout << "GetDsState In SDS done";
	  std::cout << "locPermNum:" << dsVec[0].locPermNum <<"\t";
	  for(int s = 0; s < m_pModel->procNum; s++)
		  std::cout << dsVec[0].pLoc[s] << " ";
	  std::cout << std::endl;
	  for(int k = 0; k < dsVec.size(); k++)
		  dsVec[k].Output(std::cout);
#endif	  

      //ʼֱӷ
      if(InsertAndUnviseDsState(dsVec, DsBddSet, staInserted, offset) == 0)
	  {
		  m_pCudd->PrintInfo(pinfo);
		  std::cout << "DsState Number in pastList:\t" << dsNumInPastList << std::endl;
		  return 1;
	  }
      
      //staInsertedбҪ뵽pastȥ״̬
      //Ұչɵsds뵽waitingȥҪжwaitingеsdsظϵ
      //뵽waitlinglistʱҪӾĩβӣɵ״̬Ҫ
      //жϵlocationһҲԴ
#ifdef _DEBUG
	  std::cout << "staInserted.size():" << staInserted.size() << std::endl;
#endif
      GetSdsFromDs(staInserted, offset, tmpSds.resetClockId);
      ite =  m_WaitList[index].erase(ite); //Ŀǰ״̬Ѿ꣬waitingdelete
    } 
#ifdef _DEBUG
//	std::cout << "DsBddSet:" << std::endl;
//	DsBddSet.PrintMinterm();
//	std::cout << "end dsbddset" << std::endl;
#endif

	m_pastList += DsBddSet;
  }

std::cout << "pastlist:" << std::endl;
//m_pastList.PrintMinterm();
  m_pCudd->PrintInfo(pinfo);
  std::cout << "DsState Number in pastList:\t" << dsNumInPastList << std::endl;
  return 1;
}
//watiinglistȡһsds
//ҵеsdslocation϶ӦΨһ
int StateSpace::GetSdsIndexFromWaitingList()
{
	int i;
	assert(index >= 0);
	
	//ǷҪմĵ
	for(i = index; i < m_WaitList.size(); i++)
	{
//		std::cout << m_WaitList[i].size() << std::endl;
		if(!m_WaitList[i].empty())
			return i;
	}

	for(i = 0; i < index; i++)
		if(!m_WaitList[i].empty())
			return i;

	return -1;
}
//һdsϼʣֻĿǰҪ, dsStaΪdsͷ״̬
//Ҫdsϵ״̬ȻÿһҪʼ
//0ʶ(ҵ򷵻1
int StateSpace::CheckProperty(DsState &dsSta)
{
  int i, j;
  int flag = 0;
  std::vector<DsState> vecInDs;
  DsState sta;

  //2007.3.1ûҪ⣬ȫ״̬ռ
  if(m_pModel->propertyNum <= 0)
	  return 1;
if(unfoldDS) 
{ 
	//Ҫʱ
  //õdsϵ״̬
  GetStaInDs(dsSta, vecInDs);

  for(i = 0; i < vecInDs.size(); i++)
  {
    sta = vecInDs[i];
    
    for(j = 0; j < m_pModel->propertyNum; j++)
    {
      if((m_pModel->m_property[j].type == 0) && (m_result[j] == false))
      {
        //exist property
        flag = 1;
        m_result[j] = m_pModel->m_property[j].isSatisfy(sta);
      }
      else if((m_pModel->m_property[j].type == 1) && (m_result[j] == true))
      {
        //always property
        flag = 1;
        m_result[j] = m_pModel->m_property[j].isSatisfy(sta);
      }
    }
  }
}
else
{
  for(j = 0; j < m_pModel->propertyNum; j++)
  {
	  if((m_pModel->m_property[j].type == 0) && (m_result[j] == false))
      {
		  //exist property
		  flag = 1;
		  m_result[j] = m_pModel->m_property[j].isSatisfy(dsSta);
      }
      else if((m_pModel->m_property[j].type == 1) && (m_result[j] == true))
      {
		  //always property
		  flag = 1;
		  m_result[j] = m_pModel->m_property[j].isSatisfy(dsSta);
      }
  }
}
  if(flag == 0)
  {
    //ʶѾ
    return 0;
  }
  
  return 1;
}

//õstaDSϵ״̬ŵstaInDs
void StateSpace::GetStaInDs(DsState &sta, std::vector<DsState> &staInDs)
{
  int delayLength = GetDelayLength(sta);
  int clkId;
  
  assert(delayLength >= 0);

  staInDs.clear();
  staInDs.push_back(sta);
  
  for(int i = 1; i < delayLength; i++)
  {
    DsState tmpSta = sta; //ǳcopyñĬϿ캯Ϳ
    
    //ôstadelay iõ״̬
    for(int j = 0; j < sta.clockId.size(); j++)
    {
      tmpSta.clockVarVal[j] += i;
      clkId = tmpSta.clockId[j];
      if(tmpSta.clockVarVal[j] > m_pModel->m_var[clkId-1].m_Max)
        tmpSta.clockVarVal[j] = m_pModel->m_var[clkId-1].m_Max;
    }
    staInDs.push_back(tmpSta);
  }
}

//sdsStadsͷ״̬ŵdsVec
void StateSpace::GetDsStateInSDS(SdsState &sdsSta, std::vector<DsState> &dsVec)
{
  assert(sdsSta.length >= 0);
  
  dsVec.clear();
  dsVec.push_back(sdsSta.sdsHead);
  if(sdsSta.length == 1)
    return;

  std::vector<int> NotResetId;
  int i, j, clkId, idx;
  
  for(i = 0; i < sdsSta.sdsHead.clockId.size(); i++)
  {
    clkId = sdsSta.sdsHead.clockId[i];
    if(count(sdsSta.resetClockId.begin(), sdsSta.resetClockId.end(), clkId) == 0)
      NotResetId.push_back(i);
  }
  
  for(i = 1; i < sdsSta.length; i++)
  {
    DsState tmpSta = sdsSta.sdsHead;

    for(j = 0; j < NotResetId.size(); j++)
    {
      idx = NotResetId[j];
      
      clkId = tmpSta.clockId[idx];
      tmpSta.clockVarVal[idx] += i;
      if(tmpSta.clockVarVal[idx] > m_pModel->m_var[clkId-1].m_Max)
        tmpSta.clockVarVal[idx] = m_pModel->m_var[clkId-1].m_Max;
    }
    dsVec.push_back(tmpSta);
  }
}

//չĹУʼ0򷵻1
int  StateSpace::InsertAndUnviseDsState(std::vector<DsState> &dsVec, BDD &DsBddSet,
                                        std::vector<DsState> &staInserted, std::vector<int> &offset)
{
  assert(!dsVec.empty());
  staInserted.clear();
  BDD zero = manager.bddZero();
  //ǰlocationʱӵUbound <= LboundԵǰdsУ
  //Ӻǰ
  bool allUpperBLELowB = isAllUpperBoundLEThanLowBound(dsVec[0]);
  if(allUpperBLELowB)
  {
    std::vector<int> tmpVec;
	std::vector<DsState> tmpDsVec;
    //Ӻǰ
    for(int i = dsVec.size() - 1; i >= 0; i--)
    {
      BDD bddSta = StateToBDD(dsVec[i]);

      if(((bddSta * m_pastList) == zero) && ((bddSta * DsBddSet) == zero))
      {
        if(CheckProperty(dsVec[i]) == 0) //ʶ
          return 0;

        tmpVec.push_back(i);
		tmpDsVec.push_back(dsVec[i]);

        //Եǰstate
		dsNumInPastList++;
		if(isUnvise)//
			UnvisedState(dsVec[i], DsBddSet);
		else//
			DsBddSet += bddSta;
      }
    }
    for(int j = tmpVec.size() - 1; j >= 0; j--)
	{
      offset.push_back(tmpVec[j]);
	  staInserted.push_back(tmpDsVec[j]);
	}

  }
  else
  {
    //ǰ
    for(int i = 0; i < dsVec.size(); i++)
    {
      BDD bddSta = StateToBDD(dsVec[i]);
//	  bddSta.PrintMinterm();

      if(((bddSta * m_pastList) == zero) && ((bddSta * DsBddSet) == zero))
      {
        if(CheckProperty(dsVec[i]) == 0) //ʶ
          return 0;

		offset.push_back(i);
        staInserted.push_back(dsVec[i]);
        //Եǰstate
		dsNumInPastList++;
		if(isUnvise)
			UnvisedState(dsVec[i], DsBddSet);
		else
			DsBddSet += bddSta;
      }
    }
  }

  return 1;
}
//һDsStateתΪBDDʾ
BDD StateSpace::StateToBDD(DsState &sta)
{
	int		i;
	int		*pBit;
	BDD		rlt;


	pBit = new int[totalBit];
	for(i = 0; i < totalBit; i++)
		pBit[i] = 2;
	StateToArray(sta, pBit);
#ifdef _DEBUG
	std::cout << "code: ";
	for(i = 0; i < totalBit; i++)
		std::cout << pBit[i] << " ";
	std::cout << std::endl;
#endif

	rlt = manager.arrToBdd(pBit, totalBit);
#ifdef _DEBUG
//		rlt.PrintMinterm();
#endif

	delete []pBit;
	
	return rlt;
}

//һDsState뵽pBitȥ
void StateSpace::StateToArray(DsState &sta, int *pBit)
{
	int i, begin, end;
	int clkId;

	//ʱӱ
	for(i = 0; i < sta.sharedVarVal.size(); i++)
	{
		begin = nonClkVarBitBeginIndex[i];
		end = nonClkVarBitBeginIndex[i+1] - 1;
		IdToBit(sta.sharedVarVal[i], begin, end, pBit);
	}
	
	//locationı
	for(i = 0; i < m_pModel->procNum; i++)
	{
		begin = procBitBeginIndex[i];
		end = procBitBeginIndex[i] + locBitNum[i] - 1;
		IdToBit(sta.pLoc[i]-1, begin, end, pBit);
	}

	//лʱӵֵ
	for(i = 0; i < sta.clockId.size(); i++)
	{
		clkId = sta.clockId[i];
		begin = m_pModel->m_var[clkId-1].m_CodeBeginIndex;
		end = begin + m_pModel->m_var[clkId-1].m_Bit - 1;
		IdToBit(sta.clockVarVal[i], begin, end, pBit);
	}
}

//staƵõ״̬bddʾDsBddSet
void StateSpace::UnvisedState(DsState &sta, BDD &DsBddSet)
{
  //õstaĹlocationıbddʾ
  BDD rlt = GetSharedVarAndLocBDD(sta);
#ifdef _DEBUG
  std::cout << "shared Var and loc BDD:" << std::endl;
  rlt.PrintMinterm();
  std::cout << "ҪƵ״̬" << std::endl;
  sta.Output(std::cout);
#endif

  BDD tmp;
  int Ux, Lx, clkId, locId, procId;
  
  for(int i = 0; i < sta.clockId.size(); i++)
  {
    clkId = sta.clockId[i];
    procId = m_pModel->m_var[clkId-1].m_ProcId;//ʾʱĸ
	locId = sta.pLoc[procId-1];
	
    //get the Lbound and Ubound in the location
    for(int j = 0; j < m_pModel->m_cta[procId-1].m_loc[locId-1].LUinLoc.size(); j++)
    {
      if(m_pModel->m_cta[procId-1].m_loc[locId-1].LUinLoc[j].clockId == clkId)
      {
        Ux = m_pModel->m_cta[procId-1].m_loc[locId-1].LUinLoc[j].UBound;
        Lx = m_pModel->m_cta[procId-1].m_loc[locId-1].LUinLoc[j].LBound;
        break;
      }
    }

    assert(Ux >= -1 && Lx >= -1);
    int minVal, maxVal;
    
    if(sta.clockVarVal[i] > Ux)
    {
      minVal = Ux + 1;
      maxVal = sta.clockVarVal[i];
    }
    else if(sta.clockVarVal[i] > Lx)
    {
      minVal = sta.clockVarVal[i];
      maxVal = Ux + 1;
    }
    else
    {
      minVal = maxVal = sta.clockVarVal[i];
    }
	//ƷΧ㵱ǰlocationеԼпܽһС[minVal, maxVal]
	if((m_pModel->m_var[clkId-1].minValInLoc[locId-1] != -1)
		 && (minVal < m_pModel->m_var[clkId-1].minValInLoc[locId-1]))
		minVal = m_pModel->m_var[clkId-1].minValInLoc[locId-1];
	
	if((m_pModel->m_var[clkId-1].maxValInLoc[locId-1] != -1)
		&& (maxVal > m_pModel->m_var[clkId-1].maxValInLoc[locId-1]))
		maxVal = m_pModel->m_var[clkId-1].maxValInLoc[locId-1];

	assert(minVal <= maxVal);
    //>= minVal <= maxValתΪӦbddʾ
    tmp = GetBDDFromRange(clkId, minVal, maxVal);
#ifdef _DEBUG
	std::cout << "clkId: " << clkId << "\tƷΧ: [" << minVal << " , " << maxVal << "]" << std::endl; 
	std::cout << "ƺbdd:" << std::endl;
	tmp.PrintMinterm();
#endif
    rlt *= tmp;
//	rlt.PrintMinterm();
  }

  DsBddSet += rlt;
}

BDD StateSpace::GetSharedVarAndLocBDD(DsState &sta)
{
  int i;
  int *pBit;
  BDD rlt;

  pBit = new int[totalBit];
  for(i = 0; i < totalBit; i++)
    pBit[i] = 2;
  CodeSharedVarAndLoc(sta, pBit);
  rlt = manager.arrToBdd(pBit, totalBit);
  delete []pBit;

  return rlt;
}
//staĹlocationpBit
void StateSpace::CodeSharedVarAndLoc(DsState &sta, int *pBit)
{
  int i, begin, end;
  int locIdToCode;
  
  for(i = 0; i < sta.sharedVarVal.size(); i++)
  {
    begin = nonClkVarBitBeginIndex[i];
    end = nonClkVarBitBeginIndex[i+1] - 1;
    IdToBit(sta.sharedVarVal[i], begin, end, pBit);
  }

  //code location
  for(i = 0; i < m_pModel->procNum; i++)
  {
    begin = procBitBeginIndex[i];
    end = procBitBeginIndex[i] + locBitNum[i] - 1;
    locIdToCode = sta.pLoc[i] - 1; //0ʼ¼Ĵ1ʼminus 1
    IdToBit(locIdToCode, begin, end, pBit);
  }
}

/************************************************************************************
*һõidΪƱʾŵarrУbeginendʾidarrռλ
*һʱӱxֵΪ3xֵΪ6arr[begin]=0,arr[begin+1]=1,arr[end]=1
*end - begin + 1= 3,˴ΪxҪλ
**************************************************************************************/
int StateSpace::IdToBit(int id, int begin, int end, int *pBit)
{
  while(id != 0)
  {
    pBit[end] = id & 1;
    id >>= 1;
    end--;
  }
  for(int i = begin; i <= end; i++)
    pBit[i] = 0; //ǰ油0
  
  return 1;
}

//convert minVal <= x <= maxVal to BDD, clkId is X's id
BDD StateSpace::GetBDDFromRange(int clkId, int minVal, int maxVal)
{
  int codeBeginIndex, codeEndIndex;

  codeBeginIndex = m_pModel->m_var[clkId-1].m_CodeBeginIndex;
  codeEndIndex = codeBeginIndex + m_pModel->m_var[clkId-1].m_Bit - 1;
  
  return m_pCudd->GetBddFromExpression(codeBeginIndex, codeEndIndex, maxVal, minVal);
}

bool StateSpace::isAllLowBoundLEThanUpperBound(DsState &sta)
{
  int locId;

  for(int i = 0; i < m_pModel->procNum; i++)
  {
    locId = sta.pLoc[i];
    if(m_pModel->m_cta[i].m_loc[locId-1].AllLLessEQThanU == false)
      return false;
  }

  return true;
}

bool StateSpace::isAllUpperBoundLEThanLowBound(DsState &sta)
{
  int locId;

  for(int i = 0; i < m_pModel->procNum; i++)
  {
    locId = sta.pLoc[i];
    if(m_pModel->m_cta[i].m_loc[locId-1].AllULessEQThanL == false)
      return false;
  }

  return true;
}

//dsͷ״̬stadsdelay
//for example, if ds״̬2
int StateSpace::GetDelayLength(DsState &sta)
{
  int i, j, tmp;
  int max = 65535;
  int locId, expId, varId, op, clkId;
  int varVal, rVal;
  int varMax, varMin;
  int flag = 0;

  m_pModel->pExp[0].SetCurrentState(&sta);
#ifdef _DEBUG
  sta.Output(std::cout);
#endif
  
  //Եǰڵÿlocation
  for(i = 0; i < m_pModel->procNum; i++)
  {
    locId = sta.pLoc[i];
    //ԵǰlocationÿԼ
    for(j = 0; j < m_pModel->m_cta[i].m_loc[locId-1].inv.size(); j++)
    {
      expId = m_pModel->m_cta[i].m_loc[locId-1].inv[j];
      varId = m_pModel->pExp[expId].GetLeftVarId();
      op = m_pModel->pExp[expId].GetRootOpType();
      varVal = getVarVal(&sta, varId);
      rVal = m_pModel->pExp[expId].UpdateAndCmptRightVal();
      assert(rVal >= 0);
      //locationеĲֻʱӱ
      assert(m_pModel->m_var[varId-1].m_Type == 1);
      varMax = m_pModel->m_var[varId-1].m_Max;
      varMin = m_pModel->m_var[varId-1].m_Min;
#ifdef _DEBUG
	  std::cout << "VarVal:" << varVal << "\trVal:" << rVal << std::endl;
#endif
      switch (op)
      {
        //ֻ< <=Լ
      case 2:
        //LT
        assert(varVal < rVal);
        tmp = rVal - varVal;
        flag = 1;
        if(tmp < max)
          max = tmp;
        break;
      case 3:
        assert(varVal <= rVal);
        tmp = rVal - varVal + 1;
        flag = 1;
        if(tmp < max)
          max = tmp;
        break;
      default:
        ;
      }
    }
  }

  //ûиı䣬˵û< <=Լûлʱ
  //ʱǰ״̬еĻʱӵֵҪĲ(if have actClk)
  if(flag == 0)
  {
    max = 1;
    
    for(i = 0; i < sta.clockVarVal.size(); i++)
    {
      clkId = sta.clockId[i];
      tmp = m_pModel->m_var[clkId-1].m_Max - sta.clockVarVal[i] + 1;
      if(tmp > max)
        tmp = max;
    }
  }
  
  return max;
}

void StateSpace::GetSdsFromDs(std::vector<DsState> &dsVec, std::vector<int> &offset, std::vector<int> &resetClkId)
{
  if(dsVec.size() == 0)
    return;

  int locPermNum = dsVec[0].locPermNum;
  int a, b, m, n, i, j;
  int begin, end;
  int afterUrgent = 0;

  if(m_pComp->past[locPermNum] == 0)
  {
	  std::vector<int> perm(m_pModel->procNum);
	  for(i = 0; i < m_pModel->procNum; i++)
		  perm[i] = dsVec[0].pLoc[i];
	  m_pComp->GetAllTrans(perm);
	  m_pComp->past[locPermNum] = 1;
  }
  //get the sds through every thansition
  std::list<CompTransition*>::iterator ite = m_pComp->transRules[locPermNum].begin();
  for(; ite != m_pComp->transRules[locPermNum].end(); ite++)
  {
    CompTransition *trans = *ite;
//	std::cout << "1";
    //transdsVecе״̬תõsds
    //жϵǰdsϵ״̬Ƿtrans->guardеĹԼ
    if(!SatisfySharedVarConstraint(dsVec[0], trans))
      continue;
    //жtransϵòǷתlocationĲԼ
    //ʱӲһΪ0пһ
//	std::cout << "2";
    if(!ResetClockSatisfyInvInNewLoc(dsVec[0], trans))
      continue;

    int expId, varId, op, clkId, locId;
    std::vector<int> clkIdInLocInvAndTransGuard, actAndNotResetClkId;
    std::vector<int> GConstraintInLocAndTransGuard, LConstraintInLocAndTransGuard;
    std::vector<int> clkIdInResetAndLocGuard, clkIdNotInResetButInLocGuard;
	std::vector<int> GConsExpId, LConsExpId;
	
    m_pModel->pExp[0].SetCurrentState(&dsVec[0]);
    for(i = 0; i < m_pModel->procNum; i++)
    {
      locId = dsVec[0].pLoc[i];
      for(j = 0; j < m_pModel->m_cta[i].m_loc[locId-1].inv.size(); j++)
      {
        expId = m_pModel->m_cta[i].m_loc[locId-1].inv[j];
        varId = m_pModel->pExp[expId].GetLeftVarId();
        assert(m_pModel->m_var[varId-1].m_Type == 1);
        op = m_pModel->pExp[expId].GetRootOpType();
        
        clkIdInLocInvAndTransGuard.push_back(varId);
        if(op == 2 || op == 3) // < <=
		{
          LConstraintInLocAndTransGuard.push_back(varId);
		  LConsExpId.push_back(expId);
		}
        else if(op == 4 || op == 5)// > >=
        {
          GConstraintInLocAndTransGuard.push_back(varId);
		  GConsExpId.push_back(expId);
        }
		else
		{
			assert(op == 1); //ֻǵ
			LConstraintInLocAndTransGuard.push_back(varId);
			LConsExpId.push_back(expId);
			GConstraintInLocAndTransGuard.push_back(varId);
			GConsExpId.push_back(expId);
		}
      }
    }

    for(i = 0; i < trans->guard.size(); i++)
    {
      expId = trans->guard[i];
      varId = m_pModel->pExp[expId].GetLeftVarId();
      //if varId is a sharevar's id, skip
      if(find(dsVec[0].clockId.begin(), dsVec[0].clockId.end(), varId) == dsVec[0].clockId.end())
        continue;
      assert(m_pModel->m_var[varId-1].m_Type == 1);
      op = m_pModel->pExp[expId].GetRootOpType();
        
      clkIdInLocInvAndTransGuard.push_back(varId);

      if(op == 2 || op == 3) // < <=
	  {
		LConstraintInLocAndTransGuard.push_back(varId);
		LConsExpId.push_back(expId);
	  }  
      else if(op == 4 || op == 5)// > >=
      {
        GConstraintInLocAndTransGuard.push_back(varId);
		GConsExpId.push_back(expId);
      }
	  else
	  {
		  assert(op == 1);
		  LConstraintInLocAndTransGuard.push_back(varId);
		  LConsExpId.push_back(expId);
		  GConstraintInLocAndTransGuard.push_back(varId);
		  GConsExpId.push_back(expId);
	  }
    }

    for(i = 0; i < dsVec[0].clockId.size(); i++)
    {
      int clkId = dsVec[0].clockId[i];
      if(find(resetClkId.begin(), resetClkId.end(), clkId) == resetClkId.end())
        actAndNotResetClkId.push_back(clkId);
    }

    for(i = 0; i < clkIdInLocInvAndTransGuard.size(); i++)
    {
      clkId = clkIdInLocInvAndTransGuard[i];
      if(find(resetClkId.begin(), resetClkId.end(), clkId) == resetClkId.end())
        clkIdNotInResetButInLocGuard.push_back(clkId);
      else
        clkIdInResetAndLocGuard.push_back(clkId);
    }
#ifdef _DEBUG

	int t;
    for(t = 0; t < clkIdInLocInvAndTransGuard.size(); t++)
	{
		std::cout << "clkIdInLocInvAndTransGuard[" << t << "]:" << clkIdInLocInvAndTransGuard[t] << std::endl;
	}
	std::cout << "--------------------" << std::endl;
	for(t = 0; t < LConstraintInLocAndTransGuard.size(); t++)
		std::cout << "LConstraintInLocAndTransGuard[" << t << "]:" << LConstraintInLocAndTransGuard[t] << std::endl;

	for(t = 0; t < GConstraintInLocAndTransGuard.size(); t++)
		std::cout << "GConstraintInLocAndTransGuard[" << t << "]:" << GConstraintInLocAndTransGuard[t] << std::endl;

	for(t = 0; t < clkIdNotInResetButInLocGuard.size(); t++)
		std::cout << "clkIdNotInResetButInLocGuard[" << t << "]:" << clkIdNotInResetButInLocGuard[t] << std::endl;
    
	for(t = 0; t < clkIdInResetAndLocGuard.size(); t++)
		std::cout << "clkIdInResetAndLocGuard[" << t << "]:" << clkIdInResetAndLocGuard[t] << std::endl;
#endif
	
	a = b = 0;
	GetRange(dsVec[0], resetClkId, clkIdInLocInvAndTransGuard, GConstraintInLocAndTransGuard, GConsExpId, 
		LConstraintInLocAndTransGuard, LConsExpId, &a, &b);

#ifdef _DEBUG
	    //we got a b now
    std::cout << "a: " << a << "\tb: " << b << std::endl;
#endif  
    
    //δõʱܹɢǨƵķΧ
    m = n = 0;
    GetRange(dsVec[0], clkIdNotInResetButInLocGuard, clkIdInLocInvAndTransGuard, GConstraintInLocAndTransGuard, 
		GConsExpId, LConstraintInLocAndTransGuard, LConsExpId, &m, &n);
#ifdef _DEBUG
	  std::cout << "m: " << m << "\tn: " << n << std::endl;
#endif
  
    int flag = 0;
    if(LConstraintInLocAndTransGuard.size() == 0)
    {
      flag = 1;
      begin = MAX(a, m);
      end = MAX(b, n);
    }
    else if(!hasCommonElement(LConstraintInLocAndTransGuard, resetClkId))
    {
      flag = 2;
      begin = MAX(a, m);
      end = n;
    }
    else if(!hasCommonElement(LConstraintInLocAndTransGuard, clkIdNotInResetButInLocGuard))
    {
      flag = 3;
      begin = MAX(a, m);
      end = b;
    }
    else
    {
      assert(hasCommonElement(LConstraintInLocAndTransGuard, resetClkId));
      assert(hasCommonElement(LConstraintInLocAndTransGuard, clkIdNotInResetButInLocGuard));
      flag = 4;
      begin = MAX(a, m);
      end = MIN(b, n);
    }
#ifdef _DEBUG
	std::cout << "begin:" << begin << "\tend:" << end << std::endl;
	std::cout << "transition:" << std::endl;
	trans->Output(std::cout, 1);
	std::cout << "state to jump:" << std::endl;
	dsVec[0].Output(std::cout);
#endif   

    std::vector<SdsState> sdsVecAfterJump;
    if(end < begin)
		continue;
    for(i = 0; i < dsVec.size(); i++)
    {
      int dist = offset[i] - offset[0];
      
      if(flag == 1)
      {
        begin = MAX(a, m - dist);
        end = MAX(b, n);
      }
      else if(flag == 2)
      {
        begin = MAX(a, m - dist);
        end = MAX(n-dist, 0);
      }
      else if(flag == 3)
      {
        begin = MAX(a, m-dist);
        end = b;
      }
      else
      {
        assert(flag == 4);
        begin = MAX(a, m-dist);
        int tmpB = MAX(n-dist, 0);
        end = MIN(b, tmpB);
      }

      //dsVec[i]ܷɢǨƵΪ[begin, end]
      DsState staAfterJump;
      int length = -1;
      if(end < begin)
		  continue;
      GetStateAfterJump(dsVec[i], staAfterJump, trans, begin, end, &length);
      if(length == -1)//[begin, end]֮ĶlocationеĲԼ
        continue;
      SdsState sdsSta(staAfterJump);
      sdsSta.resetClockId = trans->resetClockId;

      if(trans->isUrgent)
      {
        sdsSta.length = 1;
        afterUrgent = 1;
        sdsVecAfterJump.push_back(sdsSta);
		i = dsVec.size();
      }
      else
      {
        if(trans->resetClockId.size() == 0)
          sdsSta.length = 1;
        else
          sdsSta.length = length;

        sdsVecAfterJump.push_back(sdsSta);
      }
    }

    //insert sds in sdsVecAfterJump to waitingList
    bool transToItSelf = false;
    if(trans->pre == trans->post)
      transToItSelf = true;


#if 0
	std::cout << "state to jump:" << std::endl;
	dsVec[0].Output(std::cout);
	std::cout << "---sds after Jump:---" << std::endl;
	std::cout << "sdsVecAfterJump.size():" << sdsVecAfterJump.size() << std::endl;
    for(int q = 0; q < sdsVecAfterJump.size(); q++)
		sdsVecAfterJump[q].Output(std::cout);
	std::cout << "insert to waitinglist" << std::endl;
#endif
	
    InsertSdsToWaitingList(sdsVecAfterJump, transToItSelf);
    //sdsVecAfterJumpеsdsǾһurgentıߵõģôûбҪٸݺǨƹת
/*20070321 ޸urgent
    if(afterUrgent == 1)
    {
      ite = m_pComp->transRules[locPermNum].end();
      ite--;
    }*/

  }
}

bool StateSpace::SatisfySharedVarConstraint(DsState &sta, CompTransition *trans)
{
	if(trans->guard.size() == 0)
		return true;
	int i, varId, expId;

	m_pModel->pExp[0].SetCurrentState(&sta);
#ifdef _DEBUG
	trans->Output(std::cout, 1);
#endif
	for(i = 0; i < trans->guard.size(); i++)
	{
		expId = trans->guard[i];
		varId = m_pModel->pExp[expId].GetLeftVarId();
		if(m_pModel->m_var[varId-1].m_Type != 0)
			continue;
		assert(m_pModel->m_var[varId-1].m_Type == 0);
		if(m_pModel->pExp[expId].UpdateValAndCompute() == 0)
			return false;
	}
	
	return true;
	
}

bool StateSpace::ResetClockSatisfyInvInNewLoc(DsState &sta, CompTransition *trans)
{
	return true;
}
void StateSpace::GetRange(DsState &sta, std::vector<int> &clkIdToDealWith, std::vector<int> &clkIdInLocAndTransGuard, std::vector<int> &GConstraintInLocAndTransGuard, std::vector<int> &GConsExpId, std::vector<int> &LConstraintInLocAndTransGuard, std::vector<int> &LConsExpId,int *min, int *max)

/*void StateSpace::GetRange(DsState &sta, std::vector<int> &clkIdToDealWith, std::vector<int> &clkIdInLocInvAndTransGuard,
                          std::vector<int> &GConstraintInLocAndTransGuard, std::vector<int> &GConsExpId,
						  std::vector<int> &LConstraintInLocAndTransGuard, std::vector<int> &LConsExpId,int *min, int *max)*/
{
  int pId, locId, clkId;
  int i, j, k;

  for(i = 0; i < clkIdToDealWith.size(); i++)
  {
    pId = m_pModel->m_var[clkIdToDealWith[i]-1].m_ProcId;
    locId = sta.pLoc[pId-1];

    for(j = 0; j < m_pModel->m_cta[pId-1].m_loc[locId-1].LUinLoc.size(); j++)
    {
      if(m_pModel->m_cta[pId-1].m_loc[locId-1].LUinLoc[j].clockId == clkIdToDealWith[i])
      {
        int tmpL = m_pModel->m_cta[pId-1].m_loc[locId-1].LUinLoc[j].LBound;
        int tmpU = m_pModel->m_cta[pId-1].m_loc[locId-1].LUinLoc[j].UBound;
        int tmpB = MAX(tmpL, tmpU);
        tmpB += 1;

        for(k = 0; k < sta.clockId.size(); k++)
          if(sta.clockId[k] == clkIdToDealWith[i])
            break;
        assert(k != sta.clockId.size());
        tmpB -= sta.clockVarVal[k];
        if(tmpB > *max)
          *max = tmpB;
      }
    }
  }
  
  std::vector<int> intersectSet;
  for(i = 0; i < clkIdToDealWith.size(); i++)
  {
    clkId = clkIdToDealWith[i];
    if(find(clkIdInLocAndTransGuard.begin(), clkIdInLocAndTransGuard.end(), clkId)
       != clkIdInLocAndTransGuard.end())
      intersectSet.push_back(clkId);
  }
  
  //ҪʱӸlocationguardеԼеʱӱн
  if(intersectSet.size() > 0)
  {
    int expId, op, rVal, tmp;
    
    for(i = 0; i < intersectSet.size(); i++)
    {
      clkId = intersectSet[i];
      for(j = 0; j < GConstraintInLocAndTransGuard.size(); j++)
      {
        if(GConstraintInLocAndTransGuard[j] == clkId)
        {
          expId = GConsExpId[j];
          op = m_pModel->pExp[expId].GetRootOpType();
          rVal = m_pModel->pExp[expId].UpdateAndCmptRightVal();

          for(k = 0; k < sta.clockId.size(); k++)
            if(sta.clockId[k] == clkId)
              break;
          assert(k != sta.clockId.size());
            
          if(op == 4)
            tmp = rVal + 1 - sta.clockVarVal[k];
          else
          {
            assert(op == 5 || op == 1);
            tmp = rVal - sta.clockVarVal[k];
          }
          if(tmp > *min)
            *min = tmp;
        }
      }

      for(j = 0; j < LConstraintInLocAndTransGuard.size(); j++)
      {
        if(LConstraintInLocAndTransGuard[j] == clkId)
        {
          expId = LConsExpId[j];
          op = m_pModel->pExp[expId].GetRootOpType();
          assert(op == 2 || op == 3 || op == 1);
          rVal = m_pModel->pExp[expId].UpdateAndCmptRightVal();

          for(k = 0; k < sta.clockId.size(); k++)
            if(sta.clockId[k] == clkId)
              break;
          assert(k != sta.clockId.size());

          if(op == 2) // <
            tmp = rVal - 1 - sta.clockVarVal[k];
          else
          {
            assert(op == 3 || op == 1);
            tmp = rVal - sta.clockVarVal[k];
          }
          if(tmp < *max)
            *max = tmp;
        }
      }
    }
  }
}

//жvectorǷ йԪأйԪأtrue򷵻false
bool StateSpace::hasCommonElement(std::vector<int> &iVec1, std::vector<int> &iVec2)
{
  int i, val;

  if(iVec1.size() == 0 || iVec2.size() == 0)
    return false;

  for(i = 0; i < iVec1.size(); i++)
  {
    val = iVec1[i];

    if(find(iVec2.begin(), iVec2.end(), val) != iVec2.end())
      return true;
  }

  return false;
}

void StateSpace::InsertSdsToWaitingList(std::vector<SdsState> & sdsVec, bool transToSelf)
{
  if(sdsVec.size() == 0)
    return;
  
  std::list<SdsState>::iterator ite, begin;
  int indexToInsert = sdsVec[0].sdsHead.locPermNum;

  begin = m_WaitList[indexToInsert].begin();
  if(transToSelf)
    begin++;

  for(int i = 0; i < sdsVec.size(); i++)
  {
    ite = begin;
	int flag = 0;
    while(ite != m_WaitList[indexToInsert].end())
    {
      int length;
      // compare sdsVec[i] with *ite
      int rlt = compare(sdsVec[i], *ite, &length);
//	  std::cout << "lengthget:" << length << "\trlt: "<< rlt << std::endl;
      if(rlt == 0)//sdsVec[i]  *ite
	  {
		  flag = 1;
		  break;
	  }
      else if(rlt == 1) // sdsVec[i]*ite
      {
        (*ite).sdsHead = sdsVec[i].sdsHead;
        (*ite).length = length;
		flag = 1;
        break;
      }
      else if(rlt == -1) //*ite sdsVec[i]
      {
        (*ite).length = length;
		flag = 1;
        break;
      }
	  ite++;
    }
	if(flag == 0)
	{
		m_WaitList[indexToInsert].push_back(sdsVec[i]);
		//sdsVec[i].Output(std::cout);
	}
	else
	{
#ifdef _DEBUG
		std::cout << "Not insert to waitlist" << std::endl;
#endif		
	}
  }
}
//жsds״̬֮Ĺϵ,״̬ûظϵ-2
//leftSdsrightSds1ȷ0rigthSdsleftSds-1
// *length йϵsdsõsdsĳ
int StateSpace::compare(SdsState &leftSds, SdsState &rightSds, int *length)
{
//	leftSds.Output(std::cout);
//	rightSds.Output(std::cout); 
  if(leftSds.resetClockId.size() != rightSds.resetClockId.size())
    return -2;
  //ܷ֤ϵresetǰclkId˳?
  //Ѿ֤compositionʱԱϵresetClockIdsort
  if(!equal(leftSds.resetClockId.begin(), leftSds.resetClockId.end(), rightSds.resetClockId.begin()))
    return -2;

  //now left and right's resetClk is the same
  DsState &leftSta = leftSds.sdsHead;
  DsState &rightSta = rightSds.sdsHead;
  int i, j, clkId, lVal, rVal;
  
  //ʱӱúֵǷ
  for(i = 0; i < leftSds.resetClockId.size(); i++)
  {
    clkId = leftSds.resetClockId[i];
    for(j = 0; j < leftSta.clockId.size(); j++)
    {
      if(leftSta.clockId[j] == clkId)
      {
        lVal = leftSta.clockVarVal[j];
        break;
      }
    }
	if(j == leftSta.clockId.size())
	{
		//ʱӱãlocationϲ
		continue;
	}
	
    for(j = 0; j < rightSta.clockId.size(); j++)
    {
      if(rightSta.clockId[j] == clkId)
      {
        rVal = rightSta.clockVarVal[j];
        break;
      }
    }
    assert(j != rightSta.clockId.size());

    if(lVal != rVal)
      return -2;
  }

  //ʱӱúֵȣ鿴ֵǷһ
  if(!equal(leftSta.sharedVarVal.begin(), leftSta.sharedVarVal.end(), rightSta.sharedVarVal.begin()))
    return -2;

  //now leftSta and rigthSta's shared var is the same
  if(equal(leftSta.clockVarVal.begin(), leftSta.clockVarVal.end(), rightSta.clockVarVal.begin())) //
  {
    if(leftSds.length == rightSds.length) //sds
    {
      *length = leftSds.length;
      
      return 0;
    }
    
    else if(leftSds.length > rightSds.length) // leftSds rightSds
    {
      *length = leftSds.length;
      
      return 1;
    }
    else
    {
      *length = rightSds.length;
      
      return -1;
    }
  }
  else
  {
    //sdsͷϿsdsûаϵѾȹϵ
    //δõʱӣδõʱ֮Ĺϵж
    std::vector<int> leftClkIdNotReset, leftClkValNotReset;
    std::vector<int> rightClkIdNotReset, rightClkValNotReset;
    
    for(i = 0; i < leftSta.clockId.size(); i++)
    {
      clkId = leftSta.clockId[i];
      if(find(leftSds.resetClockId.begin(), leftSds.resetClockId.end(), clkId) == leftSds.resetClockId.end())
      {
        leftClkIdNotReset.push_back(clkId);
        leftClkValNotReset.push_back(leftSta.clockVarVal[i]);
      }
    }

    for(i = 0; i < rightSta.clockId.size(); i++)
    {
      clkId = rightSta.clockId[i];
      if(find(rightSds.resetClockId.begin(), rightSds.resetClockId.end(), clkId) == rightSds.resetClockId.end())
      {
        rightClkIdNotReset.push_back(clkId);
        rightClkValNotReset.push_back(rightSta.clockVarVal[i]);
      }
    }

    assert(leftClkIdNotReset.size() == rightClkIdNotReset.size());
    assert(leftClkIdNotReset.size() != 0);

    if(leftClkIdNotReset.size() == 1)
    {//ֻһʱûбã϶һsdsϣҪжϳȹϵ
      assert(leftClkValNotReset[0] != rightClkValNotReset[0]);
      if(leftClkValNotReset[0] > rightClkValNotReset[0])
      {
        int len = leftClkValNotReset[0] - rightClkValNotReset[0];
		if(len > rightSds.length)
          return -2;
        else
        {
          *length = MAX(rightSds.length, len + leftSds.length);
          return -1;
        }
      }
      else
      {
        int len = rightClkValNotReset[0] - leftClkValNotReset[0];
        if(len  > leftSds.length)
          return -2;
        else
        {
          *length = MAX(leftSds.length, len + rightSds.length);  
          return 1;
        }
      }
    }
    else
    {
      int rel = 0;
      
      //ϵʱûб
      for(i = 0; i < leftClkIdNotReset.size(); i++)
      {
        clkId = leftClkIdNotReset[i];
        if(leftClkValNotReset[i] < rightClkValNotReset[i])
        {
          rel = 1;
          break;
        }
        else if(leftClkValNotReset[i] > rightClkValNotReset[i])
        {
          rel = -1;
          break;
        }
      }

      assert(rel != 0);
      int id, varMax, idx;
      int count = 0;
      int step = 0;
      
      if(rel == 1)
      {
        for(i = 0; i < rightClkIdNotReset.size(); i++)
        {
          id = rightClkIdNotReset[i];
          varMax = m_pModel->m_var[id-1].m_Max;
          if(rightClkValNotReset[i] < varMax)
          {
            idx = i;
            count++;
            break;
          }
          else
          {
            int tmp = varMax - leftClkValNotReset[i];
            if(tmp > step)
              step = tmp;
          }
        }
        
        if(count == 0)//rightлʱӶﵽֵ
        {//жмȱһε
          if(step > leftSds.length)
            return -2;
          else if(step == leftSds.length)
          {
            *length = leftSds.length + 1;
            
            return 1;
          }
		  else
		  {
			  *length = leftSds.length;
			  return 1;
		  }
        }
        else
        {
          int len;
          if(leftClkValNotReset[idx] < rightClkValNotReset[idx])
          {
            len = rightClkValNotReset[idx] - leftClkValNotReset[idx];
            for(int k = 0; k < leftClkIdNotReset.size(); k++)
            {
              if(k == idx)
                continue;

              if(leftClkValNotReset[k] + len < rightClkValNotReset[k])
                return -2;
              else if(leftClkValNotReset[k] + len > rightClkValNotReset[k])
              {
                if(m_pModel->m_var[rightClkIdNotReset[k]-1].m_Max != rightClkValNotReset[k])
                  return -2;
              }
            }
          }
          else
          {
            return -2;
          }
          //left ǰ棬жlength
          if(len > leftSds.length)
            return -2;
          else
            *length = len + rightSds.length;

          return 1;
        }
      }// if(rel == 1)
      else //rel == -1
      {
        for(i = 0; i < leftClkIdNotReset.size(); i++)
        {
          id = leftClkIdNotReset[i];
          varMax = m_pModel->m_var[id-1].m_Max;
          if(leftClkValNotReset[i] < varMax)
          {
            idx = i;
            count++;
            break;
          }
          else
          {
            int tmp = varMax - leftClkValNotReset[i];
            if(tmp > step)
              step = tmp;
          }
        }
        
        if(count == 0)
        {//жмȱһε
          if(step > rightSds.length)
            return -2;
          else if(step == rightSds.length)
          {
            *length = rightSds.length + 1;
            
            return -1;
          }
		  else
		  {
			  *length = rightSds.length;
			  return -1;
		  }
        }
        else
        {
          int len;
          if(rightClkValNotReset[idx] < leftClkValNotReset[idx])
          {
            len = leftClkValNotReset[idx] - rightClkValNotReset[idx];
            for(int k = 0; k < rightClkIdNotReset.size(); k++)
            {
              if(k == idx)
                continue;

              if(rightClkValNotReset[k] + len < leftClkValNotReset[k])
                return -2;
              else if(rightClkValNotReset[k] + len > leftClkValNotReset[k])
              {
                if(m_pModel->m_var[leftClkIdNotReset[k]-1].m_Max != leftClkValNotReset[k])
                  return -2;
              }
            }
          }
          else
          {
            return -2;
          }
          //right ǰ棬жlength
          if(len > rightSds.length)
            return -2;
          else
            *length = len + leftSds.length;

          return -1;
        }
      }
    }
  }
}

//srcStatransõ״̬destStasrcStadelay beginԽjump,Ҫжɵ״̬Ƿתlocation
//вԼ㣬[begin, end]ķΧڣǲǿ㣬,*length = -1*lengthʾĳ
//Ҳתɵsdsĳ
void StateSpace::GetStateAfterJump(DsState &srcSta, DsState &destSta, CompTransition *trans, int begin, int end, int *length)
{
  int i, j, flag = -1;
//  srcSta.Output(std::cout);
  assert(begin >= 0 && end >= begin);
  for(i = begin; i <= end; i++)
  {
    destSta = srcSta;
    flag = 0;
    for(j = 0; j < destSta.clockVarVal.size(); j++)
    {
      destSta.clockVarVal[j] += i;
      if(destSta.clockVarVal[j] > m_pModel->m_var[destSta.clockId[j]-1].m_Max)
        destSta.clockVarVal[j] = m_pModel->m_var[destSta.clockId[j]-1].m_Max;
    }
    
    int newLocPermNum = trans->post;
    destSta.locPermNum = newLocPermNum;
    destSta.pLoc = m_pComp->pLocPermArr[newLocPermNum];

    updateVariable(srcSta, destSta, trans);
#ifdef _DEBUG
	std::cout << "destSta:";
	destSta.Output(std::cout);
#endif

	flag = 0;
    for(j = 0; j < m_pModel->procNum; j++)
    {
      if(!satisfy(destSta, m_pModel->m_cta[j].m_loc[destSta.pLoc[j]-1].inv))
      {
        flag = 1;
        break;
      }
    }

    if(flag == 0)
    {
      //destStaΪתɵsdsͷlength
      *length = getSDSLength(destSta, end-i+1, trans);
      assert(*length >= 1);
      
      return;
    }
  }
  assert(i == (end+1));
  *length = -1;
}

//destStatransϵĸֵ,Ҫעʱпܸı, srcStaԴ״̬
void StateSpace::updateVariable(DsState &srcSta, DsState &destSta, CompTransition *trans)
{
  bool changed = false;
  int pre, post, i, j, k;

  for(i = 0; i < trans->procId.size(); i++)
  {
    pre = srcSta.pLoc[trans->procId[i]] - 1;
    post = destSta.pLoc[trans->procId[i]] - 1;
    if(m_pModel->m_cta[trans->procId[i]].m_loc[pre].actClkId.size() != m_pModel->m_cta[trans->procId[i]].m_loc[post].actClkId.size())
    {
      changed = true;
      break;
    }

    std::pair<std::vector<int>::const_iterator,
      std::vector<int>::const_iterator>
      res = std::mismatch(m_pModel->m_cta[trans->procId[i]].m_loc[pre].actClkId.begin(),
							m_pModel->m_cta[trans->procId[i]].m_loc[pre].actClkId.end(), 
							m_pModel->m_cta[trans->procId[i]].m_loc[post].actClkId.begin());
    if(res.first != m_pModel->m_cta[trans->procId[i]].m_loc[pre].actClkId.end())
    {
      changed = true;
      break;
    }
  }

  if(changed)
  {
    //active clock differs after the jump
    int clkId, locId;
    std::vector<int> tmpVec(destSta.clockVarVal);

    destSta.clockId.clear();
    destSta.clockVarVal.clear();

    for(i = 0; i < m_pModel->procNum; i++)
    {
      locId = destSta.pLoc[i]-1;
      for(j = 0;j < m_pModel->m_cta[i].m_loc[locId].actClkId.size(); j++)
      {
        clkId = m_pModel->m_cta[i].m_loc[locId].actClkId[j];
        destSta.clockId.push_back(clkId);

        //find  if clkId is also active in srcSta
        for(k = 0; k < srcSta.clockId.size(); k++)
          if(clkId == srcSta.clockId[k])
            break;
        if(k ==  srcSta.clockId.size())
          destSta.clockVarVal.push_back(0);
        else
          destSta.clockVarVal.push_back(tmpVec[k]);
      }
    }
  }//if changed

  //updateList
  std::vector<std::pair<int, int> >::iterator ite;
  CExp *tmpPExp = m_pModel->pExp;
  tmpPExp[0].SetCurrentState(&destSta);
  for(ite = trans->updateList.begin(); ite != trans->updateList.end(); ite++)
  {
    int id = ite->first-1;
    int expId = ite->second;

    int val = tmpPExp[expId].UpdateValAndCompute();
#ifdef _DEBUG
	std::cout << "id:" << id << "\texpId:" << expId << "\tval:" << val << std::endl;
	tmpPExp[expId].dbgOutput();
#endif
	
    if(m_pModel->m_var[id].m_Type == 0)
	{	
//		std::cout << "val before modified:" << destSta.sharedVarVal[id] << std::endl;
		destSta.sharedVarVal[id] = val;
	}
    else
    {
      assert(m_pModel->m_var[id].m_Type == 1);
      for(k = 0; k < destSta.clockId.size(); k++)
      {
        if(destSta.clockId[k] == (id+1))
        {
          destSta.clockVarVal[k] = val;
          break;
        }
      }
    }
  }
}
//жstaǷexpIdVecеıʽʾĲ
bool StateSpace::satisfy(DsState &sta, std::vector<int> &expIdVec)
{
  if(expIdVec.size() == 0)
    return true;
  int i, varId, expId, rVal, varVal;
  OPTYPE op;

  m_pModel->pExp[0].SetCurrentState(&sta);
  for(i = 0; i < expIdVec.size(); i++)
  {
    expId = expIdVec[i];
    varId = m_pModel->pExp[expId].GetLeftVarId();
    op = m_pModel->pExp[expId].GetRootOpType();
    rVal = m_pModel->pExp[expId].UpdateAndCmptRightVal();
    varVal = getVarVal(&sta, varId);

    //std::cout << "varVal:" << varVal <<"\trVal:" << rVal << std::endl;
    
    switch(op)
    {
    case 4://GT
      if(varVal <= rVal)
        return false;
      break;
    case 5://GE
      if(varVal < rVal)
        return false;
      break;
    case 2://LT
      if(varVal >= rVal)
        return false;
      break;
    case 3://LE
      if(varVal > rVal)
        return false;
      break;
    case 1://EQ
      if(varVal != rVal)
        return false;
      break;
    case 6://NE
      if(varVal == rVal)
        return false;
      break;
    default:
      std::cout << "Error type in satisfy" << std::endl;
      return false;
    }
  }

  return true;
}

int StateSpace::getSDSLength(DsState &sta, int maxSDSLength, CompTransition *trans)
{
  int i, j, k;
  int tmp, varMax, varVal;
  int max = maxSDSLength;
  int tmpMax = 0;

  if(sta.clockId.size() == 0)
    return 1;
  
  m_pModel->pExp[0].SetCurrentState(&sta);
  for(i = 0; i < m_pModel->procNum; i++)
  {
    int locId = sta.pLoc[i] - 1;
	for(j = 0; j < m_pModel->m_cta[i].m_loc[locId].inv.size(); j++)
	{
      int expId = m_pModel->m_cta[i].m_loc[locId].inv[j];
      int op = m_pModel->pExp[expId].GetRootOpType();
      int varId = m_pModel->pExp[expId].GetLeftVarId();
      for(k = 0; k < trans->resetClockId.size(); k++)
      {
        if(varId == trans->resetClockId[k])
          break;
      }
      if(k < trans->resetClockId.size())
        continue;

      //varId is not a reset clock, so varVal satisfies the
      //locations inv now
      assert(m_pModel->m_var[varId-1].m_Type == 1);
      int rVal = m_pModel->pExp[expId].UpdateAndCmptRightVal();
      varVal = getVarVal(&sta, varId);
      assert(varVal >= 0);

      varMax = m_pModel->m_var[varId-1].m_Max;
      
      switch (op)
      {
      case 4: // GT
      case 5: // GE
        break;
      case 2://LT
        assert(varVal < rVal);
        tmp = rVal - 1 - varVal + 1;
        if(tmp < max)
          max = tmp;
        break;
      case 3: // LE
        assert(varVal <= rVal);
        tmp = rVal - varVal + 1;
        if(tmp < max)
          max = tmp;
        break;
      case 1: // EQ
        assert(varVal == rVal);
        max = 1;
        break;
      case 6://NQ
        assert(varVal != rVal);
        if(rVal > varVal)
        {
          tmp = rVal - 1 - varVal + 1;
          if(tmp < max)
            tmp = max;
        }
        break;
      default:
        std::cout << "Error op type" << std::endl;
        return -1;
      }//switch
      assert(max >= 1);
    }
  }
  return max;
}

void StateSpace::setVariableRangeInLoc()
{
	int i, j, k;
//	std::cout << "var size:" << m_pModel->m_var.size() << std::endl;

	for(i = 0; i < m_pModel->m_var.size(); i++)
	{
//		std::cout << "i:" << i;
		if (m_pModel->m_var[i].m_Type == 1)
		{
			int procId = m_pModel->m_var[i].m_ProcId;
//			std::cout << "\tprocId:" << procId << std::endl;
			m_pModel->m_var[i].maxValInLoc.resize(m_pModel->m_cta[procId-1].m_loc.size());
			m_pModel->m_var[i].minValInLoc.resize(m_pModel->m_cta[procId-1].m_loc.size());
			for(k = 0; k < m_pModel->m_var[i].maxValInLoc.size(); k++)
			{
				m_pModel->m_var[i].maxValInLoc[k] = -1;
				m_pModel->m_var[i].minValInLoc[k] = -1;
			}
		}
	}
	for(i = 0; i < m_pModel->procNum; i++)
	{
		for(j = 0; j < m_pModel->m_cta[i].m_loc.size(); j++)
		{
			for(k = 0; k < m_pModel->m_cta[i].m_loc[j].inv.size(); k++)
			{
				int expId = m_pModel->m_cta[i].m_loc[j].inv[k];
				int clkId = m_pModel->pExp[expId].GetLeftVarId();
				int op = m_pModel->pExp[expId].GetRootOpType();
				int rVal = m_pModel->pExp[expId].UpdateAndCmptRightVal();
//				m_pModel->pExp[expId].dbgOutput();

				switch(op) 
				{
				case 1://EQ
					m_pModel->m_var[clkId-1].maxValInLoc[j] = rVal;
					m_pModel->m_var[clkId-1].minValInLoc[j] = rVal;
					break;
				case 2: // <
					m_pModel->m_var[clkId-1].maxValInLoc[j] = rVal - 1;
					break;
				case 3: // <=
					m_pModel->m_var[clkId-1].maxValInLoc[j] = rVal;
					break;
				case 4: // >
					m_pModel->m_var[clkId-1].minValInLoc[j] = rVal + 1;
					break;
				case 5: // >=
					m_pModel->m_var[clkId-1].minValInLoc[j] = rVal;
					break;
				default:
					std::cout << "ERROR! OPTYPE error in setVariableRangeInLoc()" << std::endl;
				}
//				std::cout << "id: " << clkId << "\tlocId: " << j << " [" << m_pModel->m_var[clkId-1].minValInLoc[j] << " , "
//					<< m_pModel->m_var[clkId-1].maxValInLoc[j] << "]" <<std::endl;
				assert(m_pModel->m_var[clkId-1].maxValInLoc[j] >= m_pModel->m_var[clkId-1].minValInLoc[j]);
			}
		}
	}
}

void StateSpace::Output(std::ostream &os)
{
  int i, j;
  
  //out put the encoding information
  os << "-----------StateSpace Output--------------" << std::endl;

  os << "totalBit:\t" << totalBit << "\tnonClkVarBitNum:" << nonClkVarBitNum
     << "\tclkVarBitNum:" << clkVarBitNum << "\tlocBit:" << locBit << std::endl;

  os << "--------coding information---------" << std::endl;
  for(i = 0; i < m_pModel->shareVarNum; i++)
    os << "nonClkVarBitBeginIndex[" << i << "] : " << nonClkVarBitBeginIndex[i] << std::endl;
  
  for(i = 0; i < m_pModel->m_cta.size(); i++)
  {
    os << "proc[" << i << "] needs " << locBitNum[i] << "bits to encode the location" << std::endl;
    os << "procBitBeginIndex[" << i << "] : " << procBitBeginIndex[i] << std::endl;
  }

  os << "procBitBeginIndex[" << i << "] : " << procBitBeginIndex[i] << std::endl;
  for(i = 0; i < m_pModel->m_cta.size(); i++)
  {
    os << "clkVarBeginIndex[" << i << "][0] : " << clkVarBeginIndex[i][0] << std::endl;    
    for(j = 1; j <= clkVarBeginIndex[i][0]; j++)
      os << "clkVarBeginIndex[" << i << "][" << j << "] : " << clkVarBeginIndex[i][j] << std::endl;
  }
}






















