#ifndef RMODELCHECK_STATESPACE
#define RMODELCHECK_STATESPACE

#include "system.h"
#include "sdsState.h"
#include "composition.h"
#include "cuddObj.hh"
#include "queue"
#include "vector"
#include "map"
#include "list"
using namespace std;

class StateSpace
{
public:
	StateSpace(System *pModel, Composition *pComp);
	virtual ~StateSpace();
	
	System		*m_pModel;
	Composition *m_pComp;
	Cudd *		m_pCudd;	//
	Cudd		manager;
	BDD			m_pastList;		//bddʾ״̬ռ
    std::vector<std::list<SdsState> > m_WaitList;
	vector<bool>	m_result;   //ʼĽ
	
	int InitStateSpace();
	int	GetBitNum(int num);	
	int	GetInitState(SdsState &initSdsState);
    //generate the statespace and check the property
    int GenAndCheck(FILE *pinfo, bool notUnviseSta, bool unfold_DS);
	int GetSdsIndexFromWaitingList();
    //check property on a DsState
    int CheckProperty(DsState &dsSta);
    //õstaΪͷdsϵ״̬ŵstaInDsȥ
    void GetStaInDs(DsState &sta, std::vector<DsState> &staInDs);
    //õstaΪͷdsϵdelay
    int GetDelayLength(DsState &sta);
    //һsds״̬뵽waitlinglistУҪжwaitinglistsdsظϵ
//    void InsertSdsToWaitList(SdsState &sds);
	//õÿʱӱÿlocationinvеֵСֵ
	void setVariableRangeInLoc();
	BDD StateToBDD(DsState &sta);
	void StateToArray(DsState &sta, int *pBit);
    //һsdsչΪds
    void GetDsStateInSDS(SdsState &sdsSta, std::vector<DsState> &dsVec);
    //һdsе״̬뵽pastУƣֻҪ״̬ûɹ, offset¼ҪչDsͷ֮ľ
    int InsertAndUnviseDsState(std::vector<DsState> &dsVec, BDD &DsBddSet, std::vector<DsState> &staInserted, std::vector<int> &offset);
    //staƵõ״̬bddʾDsBddSet
    void UnvisedState(DsState &sta, BDD &DsBddSet);
    BDD GetBDDFromRange(int clkId, int minVal, int maxVal);
    //õstaĹlocationʾbdd
    BDD GetSharedVarAndLocBDD(DsState &sta);
    //õstaĹlocationı
    void CodeSharedVarAndLoc(DsState &sta, int *pBit);
    int IdToBit(int id, int begin, int end, int *arr);
    
    bool StateSpace::isAllUpperBoundLEThanLowBound(DsState &sta);
    bool StateSpace::isAllLowBoundLEThanUpperBound(DsState &sta);

    //dsɢǨƺsds뵽waitingListȥʱҪжsds֮ظϵ
    void GetSdsFromDs(std::vector<DsState> &dsVec, std::vector<int> &offset, std::vector<int> &resetClkId);
    void GetRange(DsState &sta, std::vector<int> &clkIdToDealWith, std::vector<int> &clkIdInLocAndTransGuard,
		std::vector<int> &GConstraintInLocAndTransGuard, std::vector<int> &GConsExpId,
		std::vector<int> &LConstraintInLocAndTransGuard, std::vector<int> &LConsExpId,int *min, int *max);
    
    //staڵǰlocationdelayĲ߶ٲߣ0
    //    int GetMaxDelayLengthInLoc(DsState &sta, std::vector<int> &clkIsReset, int computeReset);
    void updateVariable(DsState &srcSta, DsState &destSta, CompTransition *trans);
    bool satisfy(DsState &sta, std::vector<int> &expIdVec);
	//жstaǷtrans ϵĹԼ
	bool SatisfySharedVarConstraint(DsState &sta, CompTransition *trans);
	bool ResetClockSatisfyInvInNewLoc(DsState &sta, CompTransition *trans);
    int getSDSLength(DsState &sta, int maxSDSLength, CompTransition *trans);
    void GetStateAfterJump(DsState &srcSta, DsState &destSta, CompTransition *trans, int begin, int end, int *length);
    int compare(SdsState &leftSds, SdsState &rightSds, int *length);
    bool hasCommonElement(std::vector<int> &iVec1, std::vector<int> &iVec2);
    void InsertSdsToWaitingList(std::vector<SdsState> &sdsVec, bool transToSelf);
    
    void Output(std::ostream &os);
    
protected:
private:
	int totalBit;						//ģҪĶλ
	int locBit;							//locationҪĶλ

	int * procBitBeginIndex;			//һ״̬ıУʾÿ̱뿪ʼindex
	int	nonClkVarBitNum;				//ʱӱĶλ
	int clkVarBitNum;					//ʱӱҪĶλ
	int * nonClkVarBitBeginIndex;		//ÿ״̬Уʾÿʱӱ뿪ʼindex
	int ** clkVarBeginIndex;
	int * locBitNum;					//ÿбlocationҪλ

    int index; //չʹãʾĿǰڴsdsindex
	bool isUnvise;
	bool unfoldDS; //Ƿչdsʱʲչ
};

#endif
