#include "system.h"
#include "fileTrans.h"
#include <string>
#include <iostream>
#include <sstream>
#include <assert.h>
//char* iToStr[] = {"1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12","13", "14", "15", "16", "17", "18", "19", "20", "21", "22", "23", "24", "25", "26", "27", "28", "29", "30", "31", "32", "33", "34", "35", "36", "37", "38", "39", "40", "41", "42", "43", "44", "45", "46", "47", "48", "49", "50", "51", "52", "53", "54", "55", "56", "57", "58", "59", "60", "61", "62", "63", "64", "65", "66", "67", "68", "69", "70", "71", "72", "73", "74", "75", "76", "77", "78", "79", "80", "81", "82", "83", "84", "85", "86", "87", "88", "89", "90", "91", "92", "93", "94", "95", "96", "97", "98", "99", "100"};
System::System()
{
	clockVarNum = 0;
	procNum = 0;
	shareVarNum = 0;
	locShareVarNum = 0;
}
System::~System()
{
	std::cout << "destruct system" << std::endl;
	delete []pExp;
}

int System::ImportSystem(std::string FileName)
{
  int i, j, k, l, tmp;
  std::string str, section;
  Variable var;

  //read General information
  procNum = (int)AccINIGetPrivateProfileInt("General", "ProcessNumber", -1, FileName);

  //read Variable information
  for(i = 1; i < 65535; i++)
  {
    FormatString(str, "Name", i);
    var.name = FileTrans::ReadString("Variable", str, FileName);
    if(var.name.empty())
      break;

    FormatString(str, "InitValue", i);
    var.m_InitVal = FileTrans::ReadInt("Variable", str, FileName);

    FormatString(str, "Max", i);
    var.m_Max = FileTrans::ReadInt("Variable", str, FileName);

    FormatString(str, "Min", i);
    var.m_Min = FileTrans::ReadInt("Variable", str, FileName);

    FormatString(str, "Type", i);
    var.m_Type = FileTrans::ReadInt("Variable", str, FileName);

    if(var.m_Type == 1)
      clockVarNum++;
    else if(var.m_Type == 0)
      shareVarNum++;
    else if(var.m_Type == 3)
	  locShareVarNum++;
	else
    {
      std::cout << "Variable Type Error!" << std::endl;
      return 1;
    }
	//ô˱Ķλ
	var.m_Bit = var.GetBitNum();

    m_var.push_back(var);
  }

  //read process infomation
  ClosedTa cta;
  Location loc;
  Transition trans;
  Location::clockLU LUinfo;
  std::string tmpstr1, tmpstr2;

  for(i = 1; i <= procNum; i++)
  {
    //read process i's information
    FormatString(section, "Process", i);
    cta.clear();

    cta.name = FileTrans::ReadString(section, "ProcessName", FileName);
    cta.initLocId = FileTrans::ReadInt(section, "InitLocation", FileName);

    //read locations of process i
    FormatString(section, "Location", i);
    for(j = 1; j < 65535; j++)
    {
      loc.clear();
      FormatString(str, "Name", j);
      loc.name = FileTrans::ReadString(section, str, FileName);

      if(loc.name.empty())
        break;

      //read active clocks of location j
      for(k = 1; k < 65535; k++)
      {
        FormatString(str, "ActiveClock", j, k);
        tmp = FileTrans::ReadInt(section, str, FileName);
        if(tmp == -1)
          break;

		LUinfo.clockId = tmp;
		FormatString(tmpstr1, "Location", j);
		FormatString(tmpstr2, ".Var", tmp);
		std::string tmpstr3 = tmpstr1 + tmpstr2 + ".L";
		LUinfo.LBound = FileTrans::ReadInt(section, tmpstr3, FileName);
		LUinfo.UBound = FileTrans::ReadInt(section, tmpstr1+tmpstr2+".U", FileName);
		if(LUinfo.LBound > LUinfo.UBound)
			loc.AllLLessEQThanU = false;
		if(LUinfo.UBound > LUinfo.LBound)
			loc.AllULessEQThanL = false;

		//locationµactive clock id
        for(l = 0; l < loc.actClkId.size(); l++)
        {
          if(tmp < loc.actClkId[l])
          {
            loc.actClkId.insert(loc.actClkId.begin() + l, tmp);
			loc.LUinLoc.insert(loc.LUinLoc.begin() + l, LUinfo);
            break;
          }
        }
        if(l == loc.actClkId.size())
		{
			loc.actClkId.push_back(tmp);
			loc.LUinLoc.push_back(LUinfo);
		}
        //added 2007.2.4, notes the clock belongs to which process
		m_var[tmp-1].m_ProcId = i;
      }//end of for(k

      //read invariable of location j
      FormatString(str, "Invariable", j);
      k = FileTrans::ReadInt(section, str, FileName);
      if(k == -1 || k == 0)
        loc.noInv = true;
      else
      {//record the invariable constraints expIds
        loc.noInv = false;
        LoadConstraint(k, FileName, loc.inv);
      }

      cta.m_loc.push_back(loc);
    }//end of for(j
    cta.locNum = cta.m_loc.size();

    //read jumps of process i
    FormatString(section, "Jump", i);
    for(j = 1; j < 65535; j++)
    {
      trans.clear();

      FormatString(str, "From", j);
      trans.pre = FileTrans::ReadInt(section, str, FileName);
      if(trans.pre == -1)
        break;

      FormatString(str, "To", j);
      trans.post = FileTrans::ReadInt(section, str, FileName);

      FormatString(str, "Guard", j);
      k = FileTrans::ReadInt(section, str, FileName);
      if(k == -1 || k == 0)
        trans.noGuard = true;
      else
      {
        trans.noGuard = false;
        LoadConstraint(k, FileName,trans.guard);
      }

      FormatString(str, "iUrgent", j);
      k = FileTrans::ReadInt(section, str, FileName);
      if(k == 1)
        trans.isUrgent = true;
      else
        trans.isUrgent = false;

      // read syn
      FormatString(str, "Syn", j);
      trans.syn = FileTrans::ReadInt(section, str, FileName);
      
      FormatString(str, "SynType", j);
      trans.synType = FileTrans::ReadInt(section, str, FileName);
      
	  FormatString(str, "Broadcast", j);
      trans.isBroadcast = (FileTrans::ReadInt(section, str, FileName) >= 1) ? true : false;

      if(trans.isBroadcast == true)
        cta.broadcastId.push_back(trans.syn);		//¼ǰctaеĹ㲥

      //read assign
      for(k = 1; k < 65535; k++)
      {
        FormatString(str, "Assign", j, k);
        tmp = FileTrans::ReadInt(section, str, FileName);
        if(tmp == -1)
          break;

        assert(tmp > 0);
		assert(m_var[tmp-1].m_Type != 2);
		if(m_var[tmp-1].m_Type == 1)
        {
          trans.resetClockId.push_back(tmp);
        }
        
        FormatString(str, "exp", j, k);
        int id = FileTrans::ReadInt(section, str, FileName);
        trans.updateList.push_back(std::make_pair(tmp, id));
      }

      cta.m_loc[trans.pre-1].jumpOut.push_back(trans);
    }

    m_cta.push_back(cta);
  }//end of for(i

  //read expressions
  expNum  =(int)AccINIGetPrivateProfileInt("Expressions","TotalExpNum", -1, FileName);
  pExp = new CExp[expNum];
  std::cout << "expNum:" << expNum << std::endl;
  for(i = 0; i < expNum; i++)
  {
    pExp[i].readINI(FileName.c_str(), i);
#ifdef _DEBUG
	std::cout << "expression" << i+1 << "\t";
	pExp[i].dbgOutput();
#endif
  }

  //Output(std::cout);
  
  return 0;
}

  
void System::LoadConstraint(int offset, std::string FileName, std::vector<int>& expIdVec)
{
  expIdVec.clear();
  std::string section, str;
  int i, expId;

  FormatString(section, "Constraint", offset);
  for(i = 1; i < 65535; i++)
  {
    FormatString(str, "CmpExp-", i);
    expId = FileTrans::ReadInt(section, str, FileName);
    
    if(expId == -1)
      break;
    expIdVec.push_back(expId);
  }
}

//FIleName(objļ)жҪ
int System::LoadProperty(std::string FileName)
{
	int i, j,  tmp, var;
	std::string section("Property"), item("PropertyNum");
	Property prop;
	AtomProperty atom;
	
	propertyNum = FileTrans::ReadInt(section, item, FileName);

#ifdef _DEBUG
	std::cout << "PropNum:" << propertyNum << std::endl;
#endif

	for(i = 1; i <= propertyNum; i++)
	{
		prop.clear();
		
		//read property i's information
		FormatString(section, "Property", i);
		FormatString(item, "Type", i);
		prop.type = FileTrans::ReadInt(section, item, FileName);
		
		if(prop.type == -1)
			break;

		//read atom
		for(j = 1; j < 65535; j++)
		{
			FormatString(item, "K", i, 1, j);
			tmp = FileTrans::ReadInt(section, item, FileName);
			if(tmp == -1)
				break;
			
			FormatString(item, "N", i, 1, j);
			atom.m_is_not = FileTrans::ReadInt(section, item, FileName);
			FormatString(item, "V", i, 1, j);
			var = FileTrans::ReadInt(section, item, FileName);
			if(var > 0)
			{
				if(var > shareVarNum)
					atom.m_type = 2;
				else
					atom.m_type = 1;

				atom.m_var_id = var;
				FormatString(item, "B", i, 1, j);
				atom.m_boundary = FileTrans::ReadInt(section, item, FileName);
				FormatString(item, "R", i, 1, j);
				tmp = FileTrans::ReadInt(section, item, FileName);
				switch(tmp) 
				{
				case 1:
					atom.m_relation = EQ;
					break;
				case 2:
					atom.m_relation = G;
					break;
				case 3:
					atom.m_relation = GE;
					break;
				case 4:
					atom.m_relation = L;
					break;
				case 5:
					atom.m_relation = LE;
				case 6:
					atom.m_relation = NE;
					break;
				default:
					std::cout << "ERROR! In Load atom relation!"<< std::endl;
				}
			}
			else
			{
				atom.m_type = 3;
				atom.m_process = (-1) * var;
				FormatString(item, "B", i, 1, j);
				atom.m_loc_id = FileTrans::ReadInt(section, item, FileName);
			}
			prop.m_atomProperty.push_back(atom);
		}//end of for(j...
		m_property.push_back(prop);
	}//end for (i...

	return 0;
}

//õģcompositionlocationĸ
int System::GetLocPermNum()
{
	int i;
	locPermNum = 1;
	for(i = 0; i < m_cta.size(); i++)
		locPermNum *= m_cta[i].locNum;

	return locPermNum;
}

//sʽΪ $form$numʽfrom2
void System::FormatString(std::string & s, std::string form, int num)
{
	assert(num > 0);
	std::ostringstream os;
	os << num;
	s = form + os.str();
}
//sʽΪ$form$num1-$num2ʽActiveClock1-2
void System::FormatString(std::string & s, std::string form, int num1, int num2)
{
	assert(num1 > 0 && num2 > 0);
	std::ostringstream os1, os2;
	os1 << num1;
	os2 << num2;
	s = form + os1.str() + "-" + os2.str();
}

void System::FormatString(std::string & s, std::string form, int num1, int num2, int num3)
{
	assert(num1 > 0 && num2 > 0 && num3 > 0);
	std::ostringstream os1, os2, os3;
	os1 << num1;
	os2 << num2;
	os3 << num3;
	
	s = form + os1.str() + "-" + os2.str() + "-" + os3.str();
}

void System::Output(std::ostream &os)
{
	int i;
	for(i = 0; i < m_var.size(); i++)
	{
		os << "-------------var" << i+1 <<  "-------------" << std::endl;
		os << "name:\t" << m_var[i].name << std::endl;
		os << "initValue:\t" << m_var[i].m_InitVal << std::endl;
		os << "Max:\t" << m_var[i].m_Max << "Min:\t" << m_var[i].m_Min << std::endl;
		os << "type:\t" << m_var[i].m_Type << std::endl;
		os << "BitNum:\t" << m_var[i].m_Bit << std::endl;
	}

	for(i = 0; i < m_cta.size(); i++)
	{
		m_cta[i].Output(os, i+1);
	}
	
	if(m_property.size() > 0)
	{
		os << std::endl;

		os << "-------------Property--------------" << std::endl;
		for(i = 0;i < m_property.size(); i++)
		{
			m_property[i].Output(os, i+1);
		}
	}
	
	std::cout << "outputdone" << std::endl;
}  
